#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdint.h>
#include <sys/types.h>
#include <sys/ioctl.h>
#include <string.h>
#include <pwd.h>
#ifndef HAVE_STDINT_H
#define HAVE_STDINT_H
#endif
#include <mpegconsts.h>
#include <mpegtimecode.h>
#include <netinet/in.h>
#include <netinet/tcp.h>
#include <arpa/inet.h>
#include "vj-comm.h"
#include "support.h"
#include "callbacks.h"
#include "vj-global.h"
#include "vj-patternctrl.h"
#include "vj-effectctrl.h"
#include <stdlib.h>
#include <signal.h>
//#include "vj-server.h"
//#include "vj-client.h"

//#define LOTSOFINFO 1


static vjcomm *info;
static int go_status = 0;

int max_effects = 0;
void vj_comm_log_on() {
	
 info->log_on = 1;
}

static int alfa_cmp(const char *c1, const char *c2) {
  return strcmp(c1,c2);
}


void load_yuv4mpeg_file(GtkWidget *w, GtkFileSelection *fs) {
	gchar *filename;
	vjcomm *info = vj_comm_get_info();
	filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));

	gtk_entry_set_text(GTK_ENTRY(info->yuv4mpeg_tag->filename_entry),filename);
	gtk_widget_hide( yuvselect_dialog );
}

void load_rgb24_file(GtkWidget *w, GtkFileSelection *fs) {
	gchar *filename;
	GtkWidget *w = lookup_widget( TAG_window, "TAG_rgb24_filename");
	filename = gtk_file_selection_get_filename(GTK_FILE_SELECTION(fs));
	gtk_entry_set_text(GTK_ENTRY(w),filename);
	gtk_widget_hide( rgb24select_dialog );
}

void clear_render_list() {
	gchar *t[2];
	int i;     
	gtk_clist_freeze(GTK_CLIST(info->render->list));
	gtk_clist_clear(GTK_CLIST(info->render->list));
	//text = g_new(gchar, 1);
	t[0] = g_new(gchar,4);
	t[1] = g_new(gchar,25);
	for(i=0; i < 10; i++) {
		sprintf(t[0],"%02d",i);
		sprintf(t[1], "Empty");
		gtk_clist_append(GTK_CLIST(info->render->list),
			t);
	}
	gtk_clist_thaw(GTK_CLIST(info->render->list));

}
void clear_effect_chain() {
	gchar *t[2];
	int i;     
	gtk_clist_freeze(GTK_CLIST(info->SampleEdit->effect_chain));
	gtk_clist_clear(GTK_CLIST(info->SampleEdit->effect_chain));
	//text = g_new(gchar, 1);
	t[0] = g_new(gchar,4);
	t[1] = g_new(gchar,25);
	for(i=0; i < 10; i++) {
		sprintf(t[0],"%02d",i);
		sprintf(t[1], "<none>");
		gtk_clist_append(GTK_CLIST(info->SampleEdit->effect_chain),
			t);
	}
	gtk_clist_thaw(GTK_CLIST(info->SampleEdit->effect_chain));

}


void vj_comm_free(vj_connection *vjc) {
	if(vjc) free(vjc);
	vjc = NULL;
}

static GdkColor bgcolor;
static GtkRcStyle *style;
static GdkColormap *readcolormap;
static GdkColormap *writecolormap;
static GdkColor readcolor;
static GdkColor writecolor;


void vj_comm_make_log_window() {
	info->logmsg = lookup_widget(Log_window, "veejaylog");
	info->log_on = 0;

	readcolormap = gdk_colormap_get_system();
	writecolormap = gdk_colormap_get_system();
	writecolor.blue = 0;
	writecolor.red = 0xffff;
	writecolor.green = 0;
	if(!gdk_color_alloc(readcolormap, &readcolor)) {
		fprintf(stderr, "cannot allocate color\n");
	}
	if(!gdk_color_alloc(writecolormap, &writecolor)) {
		fprintf(stderr, "cannot allocate color\n");
	}
	gdk_color_parse("white", &bgcolor);
	gdk_color_parse("#246014", &readcolor);
	style = gtk_rc_style_new();
	style->fg[GTK_STATE_NORMAL] = bgcolor;
	style->color_flags[GTK_STATE_NORMAL] = !GTK_RC_FG;
	gtk_widget_modify_style( info->logmsg, style );
	gtk_rc_style_unref(style);

}

void vj_comm_make_effect_controls_window() {
	/* setup controls */
	info->SampleEdit->slider_p0 = lookup_widget(EffectControls_window,"SE_EffectControl_P0_Vscale");
	info->SampleEdit->slider_p1 = lookup_widget(EffectControls_window,"SE_EffectControl_P1_Vscale");
	info->SampleEdit->slider_p2 = lookup_widget(EffectControls_window,"SE_EffectControl_P2_Vscale");
	info->SampleEdit->slider_p3 = lookup_widget(EffectControls_window,"SE_EffectControl_P3_Vscale");
	info->SampleEdit->slider_p4 = lookup_widget(EffectControls_window,"SE_EffectControl_P4_Vscale");
	info->SampleEdit->slider_p5 = lookup_widget(EffectControls_window,"SE_EffectControl_P5_Vscale");
	info->SampleEdit->slider_p6 = lookup_widget(EffectControls_window,"SE_EffectControl_P6_Vscale");
	info->SampleEdit->slider_p7 = lookup_widget(EffectControls_window,"SE_EffectControl_P7_Vscale");
	info->SampleEdit->slider_p8 = lookup_widget(EffectControls_window,
		"SE_EffectControl_P8_Vscale");	


	info->SampleEdit->spinbox_p0 = lookup_widget(EffectControls_window,"SE_EffectControl_P0_spinbutton");
	info->SampleEdit->spinbox_p1 = lookup_widget(EffectControls_window,"SE_EffectControl_P1_spinbutton");
	info->SampleEdit->spinbox_p2 = lookup_widget(EffectControls_window,"SE_EffectControl_P2_spinbutton");
	info->SampleEdit->spinbox_p3 = lookup_widget(EffectControls_window,"SE_EffectControl_P3_spinbutton");
	info->SampleEdit->spinbox_p4 = lookup_widget(EffectControls_window,"SE_EffectControl_P4_spinbutton");
	info->SampleEdit->spinbox_p5 = lookup_widget(EffectControls_window,"SE_EffectControl_P5_spinbutton");
	info->SampleEdit->spinbox_p6 = lookup_widget(EffectControls_window,"SE_EffectControl_P6_spinbutton");
	info->SampleEdit->spinbox_p7 = lookup_widget(EffectControls_window,"SE_EffectControl_P7_spinbutton");
	info->SampleEdit->spinbox_p8 = lookup_widget(EffectControls_window, 
		"SE_EffectControl_P8");


	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p0)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p0_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p1)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p1_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p2)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p2_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p3)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p3_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p4)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p4_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p5)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p5_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p6)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p6_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p7)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p7_changed), (gpointer)0);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->SampleEdit->slider_p8)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_slider_p8_changed), (gpointer)0);


}

void vj_comm_make_editlist_window() {
	info->RawEdit->total_frames_label = lookup_widget(Editlist_window, "RE_total_frames_label");
	info->RawEdit->total_duration_label = lookup_widget(Editlist_window, "RE_duration_label");
	info->RawEdit->start_frame_spin = lookup_widget(Editlist_window, "RE_start_frame_spinbutton");
	info->RawEdit->end_frame_spin = lookup_widget(Editlist_window, "RE_end_frame_spinbutton");
	info->RawEdit->paste_at_spin = lookup_widget(Editlist_window, "RE_paste_at_spinbutton");
	info->RawEdit->sel_start_button = lookup_widget(Editlist_window, "RE_set_sel_start_button");
	info->RawEdit->sel_end_button = lookup_widget(Editlist_window, "RE_set_sel_end_button");
	info->RawEdit->paste_at_button = lookup_widget(Editlist_window, "RE_paste_at_button");
	info->RawEdit->copy_button = lookup_widget(Editlist_window, "RE_copy_button");
	info->RawEdit->cut_button = lookup_widget(Editlist_window, "RE_cut_button");
	info->RawEdit->crop_button = lookup_widget(Editlist_window, "RE_crop_button");
	info->RawEdit->del_button = lookup_widget(Editlist_window, "RE_delete_button");
}

void vj_comm_make_sample_window() {
	info->EditList = lookup_widget(Editlist_window,"editclist");
	
	info->SampleList = lookup_widget(SampleList_window, "SL_columnedlist");
	info->SampleEdit->sample_label = lookup_widget(Sample_window, "SE_sampleid_label");
	info->SampleEdit->duration_label = lookup_widget(Sample_window, "SE_duration_label");
 	info->SampleEdit->numframes_label = lookup_widget(Sample_window,"SE_numframes");
	info->SampleEdit->start_frame_spin = lookup_widget(Sample_window, "SE_start_frame_spinbutton");
	info->SampleEdit->end_frame_spin = lookup_widget(Sample_window, "SE_end_frame_spinbutton");
	info->SampleEdit->playback_speed_spin = lookup_widget(Sample_window, "SE_speed_spinbutton");
	info->SampleEdit->next_sample_spin = lookup_widget(Sample_window, "SE_next_sample_spinbutton");
	info->SampleEdit->max_loops_spin = lookup_widget(Sample_window, "SE_max_loops_spinbutton");
	info->SampleEdit->loop_button = lookup_widget(Sample_window, "SE_toggle_loop");
	info->SampleEdit->pingpong_button = lookup_widget(Sample_window, "SE_toggle_pingpong");
	info->SampleEdit->noloop_button = lookup_widget(Sample_window, "SE_toggle_noloop");
	info->SampleEdit->volume_slider = lookup_widget(Sample_window, "SE_Sample_Volume_Hscale");
	info->SampleEdit->volume_spin = lookup_widget(Sample_window, "SE_sample_volume_spin");
	info->SampleEdit->sample_type = lookup_widget(Sample_window, "notebook7");
	info->SampleEdit->sample_controls = lookup_widget(Sample_window, "notebook7");
	info->SampleEdit->tag_active = lookup_widget(Sample_window, "TAG_activate");
	info->SampleEdit->tag_source = lookup_widget(Sample_window, "TAG_source_name");
	info->SampleEdit->tag_id = lookup_widget(Sample_window, "TAG_id_label");
	info->total_samples = 0;
	info->total_tags = 0;
	info->EditList = lookup_widget(Editlist_window,"editclist");
	
}
void vj_comm_make_tag_window() {

	info->vloopback_tag->applications = NULL;
	info->vloopback_tag->device = NULL;
	info->vloopback_tag->parameters = NULL;
	info->vloopback_tag->device_entry = lookup_widget(TAG_window, "TAG_vloopback_device_entry");
	info->vloopback_tag->device_combo = lookup_widget(TAG_window, "TAG_vloopback_combo_use_device");
	info->vloopback_tag->application_entry = lookup_widget(TAG_window, "TAG_vloopback_use_application_entry");
	info->vloopback_tag->application_combo = lookup_widget(TAG_window, "TAG_vloopback_application_combo");
	info->vloopback_tag->application_device = lookup_widget(TAG_window, "TAG_vloopback_application_input_entry");
	info->yuv4mpeg_tag->applications = NULL;
	info->yuv4mpeg_tag->filename = NULL;
	info->yuv4mpeg_tag->parameters = NULL;	
	info->yuv4mpeg_tag->filename_entry = lookup_widget(TAG_window,"TAG_yuv4mpeg_filename");
	
	info->v4l_tag->device = NULL;
	info->v4l_tag->device_entry = lookup_widget(TAG_window, "TAG_v4l_device_entry");
	info->v4l_tag->device_combo = lookup_widget(TAG_window, "TAG_v4l_device_combo");

	info->vloopback_tag->application_input = lookup_widget(TAG_window, "TAG_vloopback_application_input");
	info->vloopback_tag->use_app =1;



}


void vj_comm_make_effect_chain_window() {

	gchar *text[2];
	gchar *t[2];
	int i=0;
	info->effects = NULL;
	
	info->SampleEdit->effect_chain = lookup_widget(EffectChain_window, "SE_chain_clist");
	info->SampleEdit->bypass_button = lookup_widget(EffectChain_window, "SE_chain_toggle_video");
	info->SampleEdit->source = lookup_widget(EffectChain_window, "SE_source_selection");
	info->SampleEdit->channel = lookup_widget(EffectChain_window, "SE_channel_spin");
	/* fill the effect chain with initial values */
	gtk_clist_freeze(GTK_CLIST(info->SampleEdit->effect_chain));
	//text = g_new(gchar, 1);
	text[0] = g_new(gchar,4);
	text[1] = g_new(gchar,100);
	for(i=0; i < SAMPLE_MAX_EFFECTS; i++) {
		sprintf(text[0], "%02d",i);
		sprintf(text[1], "<none>");
		gtk_clist_append(GTK_CLIST(info->SampleEdit->effect_chain),
			text);
	}
	gtk_clist_thaw(GTK_CLIST(info->SampleEdit->effect_chain));
	info->render->spin = lookup_widget(EffectChain_window, "SE_render_to_entry");
	info->render->list = lookup_widget(EffectChain_window, "SE_render_list");

		/* fill the effect chain with initial values */
        
	gtk_clist_freeze(GTK_CLIST(info->render->list));
	//text = g_new(gchar, 1);
	t[0] = g_new(gchar,4);
	t[1] = g_new(gchar,25);
	for(i=0; i < 10; i++) {
		sprintf(t[0],"%d",i);
		sprintf(t[1], "Empty");
		gtk_clist_append(GTK_CLIST(info->render->list),
			t);
	}
	gtk_clist_thaw(GTK_CLIST(info->render->list));


}

void vj_comm_make_effects_window() {
	info->image_effects = NULL;
	info->video_effects = NULL;


	info->SampleEdit->video_effects = lookup_widget(Effects_window,"SE_VideoEffects_List");
	info->SampleEdit->image_effects = lookup_widget(Effects_window,"SE_ImageEffect_List");
//	vj_comm_preload();
//	info->effects_loaded = 1;

}

void vj_comm_make_resize_window( ) {

	info->resize->new_width = lookup_widget(Resize_window, "resize_width_spin");
	info->resize->new_height = lookup_widget(Resize_window, "resize_height_spin");
	info->resize->org_width = lookup_widget(Resize_window, "resize_width");
	info->resize->org_height = lookup_widget(Resize_window, "resize_height");
	info->resize->ratio = lookup_widget(Resize_window, "resize_ratio");
	info->resize->ratio_val = 1;

}

void vj_logmsg(char *msg) {
	if(info->log_on) {
	char buf[9024];

	sprintf(buf,"%s\n",msg);
	
	gtk_text_insert(GTK_TEXT(info->logmsg),NULL,&writecolor,NULL,buf,-1);	
	}
}

void vj_logrmsg(char *msg) {
	if(info->log_on) {
	char buf[9024];

	sprintf(buf,"%s\n",msg);
	
	gtk_text_insert(GTK_TEXT(info->logmsg),NULL,&readcolor,NULL,buf,-1);	
	}
}


int vj_comm_set_conn(char *name, int port) {
	
	info->current_port_id = port;
	strncpy(info->current_hostname, name,strlen(name));
	return 0;
}


int vj_comm_new_connection(vj_connection *vjc, char *name, int port_id) {
	if(!vjc) return -1;
	vjc->he = gethostbyname(name);
	vjc->handle = socket( AF_INET, SOCK_STREAM, 0);
	vjc->server_addr.sin_family = AF_INET;
	vjc->server_addr.sin_port = htons(port_id);
	vjc->server_addr.sin_addr = *( (struct in_addr* ) vjc->he->h_addr );

	if ( connect( vjc->handle, (struct sockaddr*) &vjc->server_addr,
		sizeof(struct sockaddr) )==-1) {

		printf("Cannot connect to veejay host %s port %d\n",
			name, port_id);
		vj_comm_free(vjc);
		return -1;
	}
	else {
		printf("Connected to veejay host %s port %d\n", name, port_id);
	}
	
	return 0;
}

int vj_comm_status_read(char *msg) {
	int nread ;
	int n,i=0;
	char status_msg[1024];
	bzero(status_msg,1024);
	if(ioctl( info->status->handle, FIONREAD, &nread)==-1) return -1;
	if(nread == 0) return -1;

	n = recv(info->status->handle, status_msg, nread, 0);
	if(n<=0) {
		fprintf(stderr, "veejay died. this must be your lucky day.\n");
		return -1;
	}
	while( i < n ) {
		if( status_msg[i] == 'V' ) {
			int status_len=0;
			i++;
			sscanf(status_msg+i , "%03d", &status_len);
			i+=3;
			//fprintf(stderr, "[%s] \n", status_msg[i]);
			if( status_msg[i] == 'S' ) {
				i++;
				memset(msg,0, MESSAGE_SIZE);
				strncpy( msg, status_msg+i, status_len );
				return 0;
			}
		}
		i++;
	}
	return -1; 
}

int vj_comm_read(char *msg) {
	int nread = MESSAGE_SIZE;

	//ioctl( info->vjc->handle, FIONREAD, &nread);
	//if(nread == 0) return -1;
	bzero(msg, MESSAGE_SIZE);
	if( recv( info->vjc->handle, msg, nread, 0) <= 0) return -1;
	vj_logrmsg(msg);
#ifdef LOTSOFINFO
#endif
	return 0;
}

int vj_comm_arbread(char *msg, int t) {
	int len = MESSAGE_SIZE * t;
	//if( ioctl( info->vjc->handle, FIONREAD, &len)==-1) return -1;
	int nbytes = 0;

	nbytes = recv(info->vjc->handle, msg, len, 0);
	vj_logrmsg(msg);
	return nbytes;
}

int vj_comm_write(char *msg) {
	int total = 0;
	int bytes_left;
	int n;
	char block[MESSAGE_SIZE];
	bytes_left = strlen(msg) + 5;
	sprintf(block, "V%03dD%s", strlen(msg), msg);
	vj_logmsg(block);
	if(bytes_left <= 0) return -1;
	while(total < bytes_left) {
		n = send ( info->vjc->handle, block+total, bytes_left, 0);
		if(n==-1) return -1;
		total += n;
		bytes_left -= n;
	}
	
	return 0;
}



vjcomm *vj_comm_get_info() {
	return info;
}
 void vj_comm_exit() {
	close(info->vjc->handle);
	close(info->status->handle);
	if(info) free(info);
	gtk_main_quit();
}

void vj_comm_cleanup(int signum) {
	if(signum==SIGTERM || signum == SIGINT) {
#ifdef LOTSOFINFO
		fprintf(stderr, "Catched signal\n");
#endif
		vj_comm_exit();		
	}
	
}

int vj_comm_connect(char *host, int port_num) {
	if(vj_comm_new_connection(info->vjc, host, port_num) == -1) {
		fprintf(stderr, "Error connecting to %s port %d\n",host,port_num);
		vj_comm_exit();
		return -1;
	}
	return 0;
}

int vj_comm_status_connect(char *host, int port_num) {
	if(vj_comm_new_connection(info->status, host, (port_num+1))==-1) {
		fprintf(stderr,"Error connecting to %s status port %d\n",
			host,port_num);
		vj_comm_exit();
		return -1;
	}
	gdk_input_add(info->status->handle, GDK_INPUT_READ, (GdkInputFunction)
		process_status_information, (gpointer) 0);
	return 0;
}
void vj_comm_init() {
	info = (vjcomm*)malloc(sizeof(vjcomm));
	//info->vjc = (vj_connection*)malloc(sizeof(vj_connection));
  	info->vjc = (vj_connection*) malloc ( sizeof(vj_connection) );
	info->status = (vj_connection*) malloc(sizeof(vj_connection) );
	info->RawEdit = (vj_raw_edit*)malloc(sizeof(vj_raw_edit));
	info->Navigator = (vj_navigator*)malloc(sizeof(vj_navigator));
	info->SampleEdit = (vj_sample_edit*)malloc(sizeof(vj_sample_edit));
	//info->PatternEdit = (vj_pattern_editor*)malloc(sizeof(vj_pattern_editor));
	//info->PatternInstrument = (vj_pattern_instrument*)malloc(sizeof(vj_pattern_instrument));
	info->yuv4mpeg_tag = (vj_yuv4mpeg_tag*)malloc(sizeof(vj_yuv4mpeg_tag));
	info->vloopback_tag = (vj_vloopback_tag*)malloc(sizeof(vj_vloopback_tag));
	info->v4l_tag = (vj_v4l_tag*)malloc(sizeof(vj_v4l_tag));
	info->render = (vj_render*)malloc(sizeof(vj_render));
	info->resize = (vj_resize*)malloc(sizeof(vj_resize));
	info->frame_num = 0;
	info->total_frames = 0;
	info->total_samples = 0;
	info->fps = 25;
	info->slider_pause = 8;
	info->hscale_down = 0;
	info->playback_mode = VJ_PLAYBACK_MODE_PLAIN;
	info->selection_start = 0;
	info->selection_end = 0;
	info->current_effect_id = 0;
	info->current_row = 0;
	info->current_col = 0;
	info->pattern_size = 0;
	info->default_blend_id = 0;
	info->effect_chain = 0;
	info->current_sample_id = 0;
	info->sample_start = 0;
	info->sample_end = 0;
	info->selected_sample = 0;
	info->selected_row = 0;
	info->playback_speed = 0;
	info->next_sample = 0;
	info->max_loops = 0;
	info->looptype = 0;
	info->new_sample_start = 0;
	info->new_sample_end = 0;
	info->status_text = lookup_widget(MainWindow,"text4");
	info->video_bar = lookup_widget(MainWindow, "timehscale");
	info->playmode_box = lookup_widget(MainWindow, "topcombo_set_playmode");
	info->RawEdit->sel_paste_at = 0;
	info->RawEdit->sel_start_at = 0;
	info->RawEdit->sel_end_at = 0;
	info->Navigator->current_frame_label = lookup_widget(MainWindow, "toplabel_totalframes");
	info->Navigator->current_timecode_label = lookup_widget(MainWindow, "top_timecode");
	info->Navigator->audio_toggle = lookup_widget(MainWindow, "toptoggle_audio");
	info->Navigator->effect_toggle = lookup_widget(MainWindow, "toptoggle_effects");
	info->SampleEdit->source_number = 0;
	info->SampleEdit->channel_number = 0;
	info->SampleEdit->bypass_update = 0;
	info->SampleEdit->bypass_entry = 0;
	info->SampleEdit->selected_effect_id = 0;
	info->SampleEdit->speed_pressed = 0;
	info->SampleEdit->next_sample_pressed = 0;
	info->SampleEdit->max_loops_pressed = 0;
	info->SampleEdit->start_frame_pressed = 0;
	info->SampleEdit->end_frame_pressed = 0;
	info->SampleEdit->slider_down = 0;
	info->SampleEdit->new_image_effect = -1;
	info->SampleEdit->new_video_effect = -1;
	info->SampleEdit->activate_tag = 0;
	info->chain_entry = -1;
	info->total_tags = 0;
	info->entry_active = 0;
	info->top_effects_toggle = 0;
	info->selected_sample_type = 0;
	vj_comm_make_log_window();
	/*
	info->PatternInstrument->selected_row = 0;
	info->PatternInstrument->selected_column = 0;
	info->PatternInstrument->LumaTransitions = NULL;
	info->PatternInstrument->TranslationTransitions = NULL;
	info->PatternInstrument->MotionTransitions = NULL;
	info->PatternInstrument->ImageEffects = NULL;
	info->PatternInstrument->VideoEffects = NULL;
	info->PatternInstrument->StaticEffects = NULL;
	
	//info->PatternEditor = lookup_widget(MainWindow, "trackerwidget");
	info->PatternEdit->row = -1; 
	info->PatternEdit->column = -1;
	//info->tracker = TRACKER(info->PatternEditor);
	*/	
	/* connect signal to videobar */

	signal( SIGINT, vj_comm_cleanup);
	signal( SIGTERM, vj_comm_cleanup);

	gtk_signal_connect(GTK_OBJECT(GTK_RANGE(info->video_bar)->adjustment),
		"value_changed", GTK_SIGNAL_FUNC(on_videobar_changed), (gpointer)0);

	  gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(yuvselect_dialog)->ok_button),
	"clicked", (GtkSignalFunc) load_yuv4mpeg_file, yuvselect_dialog);

	gtk_signal_connect(GTK_OBJECT(GTK_FILE_SELECTION(rgb24select_dialog)->ok_button),
	"clicked", (GtkSignalFunc) load_rgb24_file, rgb24select_dialog);

	//gtk_signal_connect(GTK_OBJECT(info->PatternEditor), "patpos", 
	//	GTK_SIGNAL_FUNC(update_vscrollbar), (gpointer)0);

	//gtk_signal_connect(GTK_OBJECT(info->PatternEditor), "xpanning",
	//	GTK_SIGNAL_FUNC(update_hscrollbar), (gpointer)0);

 	//gtk_signal_connect(GTK_OBJECT(info->PatternEditor), "mainmenu_blockmark_set",
	//	GTK_SIGNAL_FUNC(update_mainmenu_blockmark), (gpointer)0);

  	//gtk_signal_connect(GTK_OBJECT(MainWindow), "key-press-event", GTK_SIGNAL_FUNC(keyevent),
//		(gpointer)1);

	//gtk_signal_connect(GTK_OBJECT(MainWindow), "key-release-event", GTK_SIGNAL_FUNC(keyevent),
	//	(gpointer)0); 

	/* setup the other windows */
	vj_comm_make_effects_window();
	vj_comm_make_effect_controls_window();
	vj_comm_make_effect_chain_window();
	vj_comm_make_editlist_window();

	vj_comm_make_sample_window();
	vj_comm_make_tag_window();

	vj_comm_make_resize_window();
//	info->log_on = 1;
	
}	


void vj_comm_getwd() {
	char msg[MESSAGE_SIZE];
	if(strcmp( info->current_hostname, "localhost" )==0 || strcmp(info->current_hostname, "127.0.0.1")==0) {

	sprintf(msg ,"%d", MSG_CMD_GETWD);
	vj_comm_write(msg);
	vj_comm_read(msg);
	fprintf(stderr,"%s\n",msg);	
	strncpy(info->veejay_path,msg,strlen(msg));
	}
	else {
	  fprintf(stderr, "You are running gveejay on a remote machine, please make sure\n");
  	  fprintf(stderr, "that veejay is started in a shared network directory\n");
	  fprintf(stderr, "and that gveejay can access the files in the shared network directory from\n");
	  fprintf(stderr, "within its current working directory.\n");
	  fprintf(stderr, "This is an untested feature, bugreports are very welcome.\n");
	}

}

 void vj_effect_get_info(int i,int num_params, vj_effect_data* ved) {
	int req_id,min,max,default_value;
	char cmd_msg[MESSAGE_SIZE];
	GtkObject *adj;
	int j;
	for(j=0; j < num_params; j++ ) {
		sprintf(cmd_msg, "%d %d %d", MSG_REQ_GET_EFFECTLIMITS,i,j);
		//write(request_pipe, cmd_msg, MESSAGE_SIZE);
		vj_comm_write(cmd_msg);
		//n = read(input_pipe, cmd_msg, MESSAGE_SIZE);
		if(vj_comm_read(cmd_msg)==0 ) {
			sscanf(cmd_msg, "%d %d %d %d",
				&req_id,
				&min,
				&max,
				&default_value
			);
					  
			if(j==0) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p0),GTK_ADJUSTMENT(adj));
			}		
			if(j==1) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p1),GTK_ADJUSTMENT(adj));
			}	
			if(j==2) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p2),GTK_ADJUSTMENT(adj));
			}
			if(j==3) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p3),GTK_ADJUSTMENT(adj));
			}
			if(j==4) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
					gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p4),GTK_ADJUSTMENT(adj));
			}
			if(j==5) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
					gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p5),GTK_ADJUSTMENT(adj));
			}
			if(j==6	) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p6),GTK_ADJUSTMENT(adj));
			}		
			if(j==7) {
				adj = gtk_adjustment_new(default_value,min,max,1,5,10);
				gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(
				info->SampleEdit->spinbox_p7),GTK_ADJUSTMENT(adj));
			}		
		}
	}
}	


static int videoeffects = 0;
void vj_comm_max_effects() {
	int r, me;
	videoeffects = 0;
	sprintf(info->cmd_msg, "%d", MSG_REQ_EFFECT_COUNT);
	vj_comm_write(info->cmd_msg);
	vj_comm_read(info->cmd_msg);
	sscanf(info->cmd_msg, "%d %d %d", &r,&me, &videoeffects);
	
	if(me>0 && me < 200) { /* we for sure dont get 200 effects before updating the gui */
		max_effects = me;
	}
}


void vj_comm_preload() {
	char *big_msg; 
	int len = 0;
	int offset = 0;
	int i;
	gchar *text[1];
	vj_effect_data *ved;

	vj_comm_max_effects();


	if(info->effects_loaded==1) return; 
	big_msg = (char*)malloc(sizeof(char)*max_effects*1024);
	if(!big_msg) return;
	
	sprintf(info->cmd_msg, "%d", MSG_REQ_GET_ALL_EFFECTS);
	vj_comm_write(info->cmd_msg);
	len = vj_comm_arbread(big_msg, (max_effects*2));

	for(i=0; i < max_effects; i++) {
		char line[1024];
		char effectname[100];
		int effectlen = 0;
		int lineoffset = 0;
		int effect_id =0;
		int num_params = 0;
		int extra_frame = 0;
		int j = 0;
		int line_len = 0;

		bzero(line,1024);
		
		sscanf(big_msg+offset, "%03d", &line_len);
		offset += 3;
		strncpy(line, big_msg+offset, line_len);
		offset += line_len;
		
		sscanf(line, "%02d", &effectlen);
		lineoffset += 2;
		strncpy(effectname, line+lineoffset, effectlen);
		effectname[effectlen]='\0';
		lineoffset += effectlen;

		sscanf(line+lineoffset, "%03d%1d%1d",&effect_id, &num_params, &extra_frame);
		lineoffset += 5;
		ved = vj_effect_new( effectname, extra_frame );
		text[0] = g_strdup( ved->description );

		for(j=0; j < num_params; j++) {
			int min=0,max=0,default_value=0;
			sscanf(line+lineoffset, "%04d%04d%04d",&min,&max,&default_value);
			lineoffset+=12;
			ved->minimum_values = g_list_append(ved->minimum_values, GINT_TO_POINTER(min));
			ved->maximum_values = g_list_append(ved->maximum_values, GINT_TO_POINTER(max));
			ved->default_values = g_list_append(ved->default_values, GINT_TO_POINTER(default_value));		
		}
		info->effects = g_list_append(info->effects,ved);
	
		if(i>0 && i < videoeffects) {
			info->video_effects = g_list_append(info->video_effects, g_strdup(text[0]));
			gtk_clist_append(GTK_CLIST(info->SampleEdit->video_effects),text);
		}
		if(i > videoeffects && i <= max_effects) {
			info->image_effects = g_list_append(info->image_effects, g_strdup(text[0]));
			gtk_clist_append(GTK_CLIST(info->SampleEdit->image_effects), text);
		}	
		if(text[0]) g_free(text[0]);
	
		
	}
	//get_editlist_info();
	/* now sort the effects */
	gtk_clist_set_sort_column( GTK_CLIST( info->SampleEdit->image_effects ), 0);
	gtk_clist_set_sort_type( GTK_CLIST( info->SampleEdit->image_effects), GTK_SORT_ASCENDING);
	gtk_clist_sort( GTK_CLIST(info->SampleEdit->image_effects));

	gtk_clist_set_sort_column( GTK_CLIST(info->SampleEdit->video_effects), 0);
	gtk_clist_set_sort_type( GTK_CLIST(info->SampleEdit->video_effects), GTK_SORT_ASCENDING);
	gtk_clist_sort( GTK_CLIST(info->SampleEdit->video_effects));
	
	info->effects_loaded=1;
}
	
	
	
	
void get_editlist_info() {
	gint req_id=0;
	gint nfiles=0;
	gchar *text[2];
	gchar duration[64];
	gchar filename[64];
	gchar filelen[5];
	gchar nfile[4];
	char big_msg[(10*MESSAGE_SIZE)];
	gint i=0;
	gint row = 0;
	gint file_len = 0;
	/* get the number of files in editlist */
	bzero(big_msg, (10*MESSAGE_SIZE));
	sprintf(info->cmd_msg, "%d", MSG_REQ_FLOOD_EDITLIST);
	vj_comm_write(info->cmd_msg);
	vj_comm_arbread(big_msg,(10*MESSAGE_SIZE));
	sscanf(big_msg, "%d %d", &req_id, &nfiles);
	if(req_id != MSG_REQ_FLOOD_EDITLIST) return;

	if(nfiles > 0) {
		int offset = 9;
		gtk_clist_freeze(GTK_CLIST(info->EditList));
		gtk_clist_clear(GTK_CLIST(info->EditList));
		for(i=0; i < nfiles; i++) {
			strncpy(nfile,big_msg+offset,3);
			offset+=3;
			nfile[3] = '\0';

			strncpy(filelen, big_msg+offset, 4);
			offset+=4;
			filelen[4] = '\0';

			sscanf(filelen, "%04d", &file_len);
			strncpy(filename, big_msg+offset, file_len);
			filename[file_len] = '\0'; 
			offset += file_len;
			//offset += 4;
			strncpy(duration, big_msg+offset, 11);
			duration[11] = '\0';
			offset+=11;
			text[0] = g_new(gchar,5);
			sprintf(text[0], "%s", nfile);
			text[1] = NULL;
			text[2] = NULL;
			row = gtk_clist_append(GTK_CLIST(info->EditList),text);
			gtk_clist_set_text(GTK_CLIST(info->EditList),row,1,filename);
			gtk_clist_set_text(GTK_CLIST(info->EditList),row,2,duration);
		}
		gtk_clist_thaw(GTK_CLIST(info->EditList));
	}
}

void tag_get_info() {
	char msg[MESSAGE_SIZE];
	int command,useable_devices=0;
	char *device, *flag, *cmd_name, *cmd_num;
	GList *hwlist = NULL;
	GList *vlist = NULL;
	GList *devlist = NULL;
	sprintf(msg, "%d", MSG_REQ_GET_DEVICES);

	vj_comm_write(msg);
	vj_comm_read(msg);	

	sscanf(msg, "%d %d", &command, &useable_devices);
	fprintf(stderr, "There are %d available video devices on your system\n",useable_devices);
	cmd_name = strtok(msg, " ");
	cmd_num = strtok(NULL," ");
	while(useable_devices) {
		device=	strtok(NULL, "  ");
		flag = strtok(NULL," ");
		if(strcmp(flag,"H")==0) {
			/* Hardware, this is v4l */
			hwlist = g_list_append( hwlist, device);
			devlist = g_list_append( devlist, device);

		}
		if(strcmp(flag, "W")==0) {
			/* vloopback */
			vlist = g_list_append( vlist, device);
			devlist = g_list_append( devlist, device);
		}
		if(strcmp(flag, "F")==0) {
			//devlist = g_list_append( devlist, device);
		}
		useable_devices--;
	}
	if(devlist!=NULL)
		gtk_combo_set_popdown_strings( GTK_COMBO(info->vloopback_tag->application_input), devlist);
	if(hwlist!=NULL)
		gtk_combo_set_popdown_strings( GTK_COMBO(info->v4l_tag->device_combo), hwlist );
	if(vlist!=NULL)
		gtk_combo_set_popdown_strings( GTK_COMBO(info->vloopback_tag->device_combo),vlist);

}
int tag_app_find_free_pipe(char *filename, int type ) {
	char msg[MESSAGE_SIZE];
	int command,useable_devices=0;
	char *device, *flag, *cmd_name, *cmd_num;
	sprintf(msg, "%d", 300);
	vj_comm_write(msg);
	vj_comm_read(msg);	
	sscanf(msg, "%d %d", &command, &useable_devices);
	cmd_name = strtok(msg, " ");
	cmd_num = strtok(NULL," ");
	while(useable_devices) {
		device=	strtok(NULL, "  ");
		flag = strtok(NULL," ");
		if(type==3) {
			if(strcmp(flag,"F")==0) {
				sprintf(filename,"%s",device);
				return 1;
			}
		}
		else {
			if(strcmp(flag,"H")==0 && type==0 && strcmp(device,filename)==0) {
				/* Hardware, this is v4l */
				sprintf(filename,"%s", device);
				return 1;
			}
			if(strcmp(flag, "F")==0 && type==1 && strcmp(device,filename)==0) {
				/* vloopback */
				sprintf(filename,"%s", device);
				return 1;
			}
			if(strcmp(flag,"W")==0 && type==2 ) {
				int pipe_id = 0; /* get input side */
				sscanf(device+5,"%d", &pipe_id);
				sprintf(filename, "video%d",(pipe_id+1));
				return 1;
			}
		}
		useable_devices--;
	}
	return 0;
}


void v4l_create() {
	char *video_device = gtk_entry_get_text( GTK_ENTRY(info->v4l_tag->device_entry) );
	char cmd[MESSAGE_SIZE];
	int c,r;
	if(video_device==NULL || strncmp(video_device, "video",5)!=0) return;

	sprintf(cmd, "%d %s", MSG_REQ_NEW_V4L, video_device);
	vj_comm_write(cmd);
	vj_comm_read(cmd);
	sscanf(cmd, "%d %d", &c, &r);
	if(r!=0) {
		sprintf(cmd,"%d 4 %d", MSG_CMD_SET_PLAYMODE, r);
		vj_comm_write(cmd);
	}
	gtk_clist_clear(GTK_CLIST(info->SampleList));
	info->total_tags = 0;

}


void yuv4mpeg_create() {
	char *filename = gtk_entry_get_text(GTK_ENTRY(info->yuv4mpeg_tag->filename_entry));
	char cmd[MESSAGE_SIZE];
	int r,c;

	sprintf(cmd, "%d %s", MSG_REQ_NEW_YUV4MPEG, filename);
	vj_comm_write(cmd);
	vj_comm_read(cmd);
	sscanf(cmd, "%d %d", &c, &r);
	if(r!=0) {
		sprintf(cmd,"%d 4 %d", MSG_CMD_SET_PLAYMODE,r);
		vj_comm_write(cmd);
	}
	gtk_clist_clear(GTK_CLIST(info->SampleList));
	info->total_tags = 0;


}

void rgb24_create() {
	GtkWidget *w = lookup_widget(TAG_window, "TAG_rgb24_filename");
	char *filename = gtk_entry_get_text(GTK_ENTRY(w));
	char cmd[MESSAGE_SIZE];
	int r,c;

	sprintf(cmd, "%d %s", MSG_REQ_NEW_RAW, filename);
	vj_comm_write(cmd);
	vj_comm_read(cmd);
	sscanf(cmd, "%d %d", &c, &r);
	if(r!=0) {
		sprintf(cmd,"%d 4 %d", MSG_CMD_SET_PLAYMODE,r);
		vj_comm_write(cmd);
	}
	gtk_clist_clear(GTK_CLIST(info->SampleList));
	info->total_tags = 0;
}


void vloopback_create() {
	if(info->vloopback_tag->use_app==0) {
		char *video_device = gtk_entry_get_text(GTK_ENTRY(info->vloopback_tag->device_entry));
		char cmd[MESSAGE_SIZE];
		int write_side;
		 char video_to[1024];
		int c,r;
		if(video_device==NULL || strncmp(video_device, "video",5)!=0) return;
		sscanf(video_device+5,"%d",&write_side);
		sprintf(video_to,"/dev/video%d",write_side+1);

		sprintf(cmd, "%d %s", MSG_REQ_NEW_VLOOPBACK_BY_NAME,video_to);
		vj_comm_write(cmd);
		vj_comm_read(cmd);
		sscanf(cmd, "%d %d", &c, &r);
		if(r != 0) {
			sprintf(cmd, "%d 4 %d", MSG_CMD_SET_PLAYMODE,r);
			vj_comm_write(cmd);
		}
	gtk_clist_clear(GTK_CLIST(info->SampleList));
	info->total_tags = 0;

	//	get_all_tags(r);
	}
	else if(info->vloopback_tag->use_app==1) {
		char *appname = gtk_entry_get_text(GTK_ENTRY(info->vloopback_tag->application_entry));
		char *use_device = gtk_entry_get_text(GTK_ENTRY(info->vloopback_tag->application_device));
		char a_device[255];
		char v_device[255];
		
		char size[255];
		int width,height,id;
		if(tag_app_find_free_pipe(use_device, 0 )==1) {
		}
		if(tag_app_find_free_pipe(use_device,2)==1) {
		}	
		if(strcmp(appname,"EffecTV")==0) {
			sprintf(a_device, "-device /dev/%s",use_device);
			if(tag_app_find_free_pipe(use_device, 3)==1) {
				char cmd[MESSAGE_SIZE];
				char effectv[MESSAGE_SIZE];
				
				int ret = 0;	
				sprintf(cmd, "%d", MSG_REQ_VIDEO_PROPERTIES);
				vj_comm_write(cmd);
				vj_comm_read(cmd);
				sscanf(cmd, "%d %d %d", &id, &width, &height);
				sprintf(size, "-size %dx%d",width,height);
				sprintf(v_device, "-vloopback /dev/%s", use_device);
				sprintf(effectv,"effectv %s %s %s &",a_device,v_device,size);
				ret = system(effectv);
				/*		
				fprintf(stderr, "%s",effectv);
				if(ret!=-1) {
					char cmd[MESSAGE_SIZE];
					int pipe=0;
					int c, r;
					sscanf( use_device+5, "%d", &pipe);
					pipe += 1;
					sprintf(cmd, "%d video%d",MSG_REQ_NEW_VLOOPBACK_BY_NAME,pipe);
					vj_comm_write(cmd);
					vj_comm_read(cmd);
					sscanf(cmd, "%d %d", &c, &r);
					if(r!=0) {
				 	   sprintf(cmd, "%d 4 %d", MSG_CMD_SET_PLAYMODE, r);	
					   vj_comm_write(cmd);	
					}
					else {
					  
					}
				}
				*/
			}	
		}
	}
} 

void samplelist_update() {
	char id[5];
	char duration[10];
	char description[150];
	int n=0;
	char cmd[MESSAGE_SIZE];
	return;

	if(!valid_mode_sample()) return;
	sprintf(cmd, "%d %d", MSG_REQ_GET_SAMPLE_INFO, info->current_sample_id);
	n = vj_comm_write(cmd);

	n = vj_comm_read(cmd);
	if(n>0) {
	sscanf(cmd, "%s %s %s", id, duration, description);
	if(description==NULL || strlen(description)<=0) 
		sprintf(description, "%s", " ");
	gtk_clist_set_text(GTK_CLIST(info->SampleList),info->current_sample_id-1,1,duration);
	gtk_clist_set_text(GTK_CLIST(info->SampleList),info->current_sample_id-1,2,description);
	}
}

void get_all_tags(int numsamples) {
	gint i;
	char id[6];
	gchar duration[20];
	char source[150];
	gchar *text[2];
	int offset = 0;
	int row;
	int len = 0;
	int numtags = 0;
	int req_id = 0;
	/* how many tags are there ?*/
	sprintf(info->cmd_msg, "%d", MSG_REQ_GET_NR_TAGS);
	vj_comm_write(info->cmd_msg);
	/* extract info */
	vj_comm_read(info->cmd_msg);


	sscanf(info->cmd_msg, "%d %04d", &req_id, &numtags);
	if(req_id != MSG_REQ_GET_NR_TAGS) return;
	if(numtags == 0) {
		fprintf(stderr, "Currently there are no tags present\n");
	}
	if(numtags > 0) {
		char *big_msg = (char*)malloc(sizeof(char)*numtags*MESSAGE_SIZE);
		bzero(info->cmd_msg,MESSAGE_SIZE);
		sprintf(info->cmd_msg, "%d",MSG_REQ_FLOOD_TAGS);
		vj_comm_write(info->cmd_msg);
		sprintf(duration, "%s", "-----------");
		if(vj_comm_arbread(big_msg,numtags)!=-1) {
			gtk_clist_freeze(GTK_CLIST(info->SampleList));
			for(i=1; i <= numtags; i++) {
				sscanf(big_msg+offset, "%04d %s %s ",&len,&id,&source);
				if(strcmp(source, "-X-")!=0) {	
				text[0] = g_new(gchar,5);
				sprintf(text[0], "%s", id);
				text[1] = NULL;
				text[2] = NULL;
				row = gtk_clist_append(GTK_CLIST(info->SampleList),text);
				gtk_clist_set_text(GTK_CLIST(info->SampleList),row, 1, duration);		
				gtk_clist_set_text(GTK_CLIST(info->SampleList),row, 2, source);	
				}
				offset+=len;
			}
		
			gtk_clist_thaw(GTK_CLIST(info->SampleList));
		}
		free(big_msg);
	}
	//fprintf(stderr, "END\n");
	return ;
}

void get_all_samples(int numsamples2) {
	gint i;
	char id[6];
	char duration[12];
	char source[150];
	gchar *text[2];
	int offset = 0;
	int len = 0;
	int row;
	int numsamples=0;
	int req_id=0;
	/* clear list, insert all new samples */
	gtk_clist_freeze(GTK_CLIST(info->SampleList));

	sprintf(info->cmd_msg, "%d", MSG_REQ_GET_NR_SAMPLES);
	vj_comm_write(info->cmd_msg);
	vj_comm_read(info->cmd_msg);
	sscanf(info->cmd_msg,"%d %04d",&req_id, &numsamples);
	if(req_id!=MSG_REQ_GET_NR_SAMPLES) {
		fprintf(stderr, "Unexpected reply %d : [%s]\n",req_id,info->cmd_msg);
	}
	else {
		char *tmpbuf = (char*)malloc(sizeof(char) * (numsamples+1) * MESSAGE_SIZE);
		sprintf(info->cmd_msg, "%d", MSG_REQ_FLOOD_SAMPLES);
		vj_comm_write(info->cmd_msg);
		//fprintf(stderr, "START %d\n",numsamples);
		if(vj_comm_arbread(tmpbuf,numsamples)!=-1) {
		for(i=0; i < numsamples; i++) {
			sscanf(tmpbuf+offset, "%04d",&len);
			offset += 4;
			if(len>0) {
				strncpy(id, tmpbuf+offset, 5);
				id[5] = '\0';
				offset += 5;
				strncpy(duration, tmpbuf+offset,11);
					offset += 11;
				duration[11] = '\0';
				sscanf(tmpbuf+offset,"%s ", source);
				offset += strlen(source)+1;
				if( strlen(id) > 0) {
				
				text[0] = g_new(gchar,5);
					sprintf(text[0], "%s", id);
				text[1] = NULL;
				text[2] = NULL;
				row = gtk_clist_append(GTK_CLIST(info->SampleList),text);
				gtk_clist_set_text(GTK_CLIST(info->SampleList),row, 1, duration);		
				gtk_clist_set_text(GTK_CLIST(info->SampleList),row, 2, source);	
				}
			}
		//fprintf(stderr, "offset = %d, len = %d\n",offset,len);
	}
	}
	//fprin	tf(stderr, "END\n");
	
		if(tmpbuf) free(tmpbuf);
		gtk_clist_thaw(GTK_CLIST(info->SampleList));
	}
}


void msg_no_sample() {
	sprintf(info->stat_msg, "Please select a sample from the Sample List first\n");
	gtk_text_insert(GTK_TEXT(info->status_text), NULL,NULL,NULL, info->stat_msg, -1);
}


/* update chain entry is called when the current chain entry changes. 
   the effect controls need to be updated when this happens. */
  void update_effect_control_limits(GtkWidget *widget, int param) {
	GtkObject *adj;
	gint max_val, min_val;
	min_val = vj_effect_get_min_value(info->current_effect_id, param);
	max_val = vj_effect_get_max_value(info->current_effect_id, param);
#ifdef LOTSOFINFO
	printf("min value for param %d is %d, max is %d\n",param,min_val,max_val);
#endif
	adj = gtk_adjustment_new(0,min_val,max_val,1,5,10);
	gtk_spin_button_set_adjustment(GTK_SPIN_BUTTON(widget), GTK_ADJUSTMENT(adj));
}

  void update_effect_control_values() {
	//fprintf(stderr, "empty body\n");	
}

  void disable_raw_edit() {

	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->start_frame_spin))
		gtk_widget_set_sensitive(info->RawEdit->start_frame_spin,FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->end_frame_spin))
		gtk_widget_set_sensitive(info->RawEdit->end_frame_spin, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->paste_at_spin))
		gtk_widget_set_sensitive(info->RawEdit->paste_at_spin, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->sel_start_button))
		gtk_widget_set_sensitive(info->RawEdit->sel_start_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->sel_end_button))		
		gtk_widget_set_sensitive(info->RawEdit->sel_end_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->copy_button))
		gtk_widget_set_sensitive(info->RawEdit->copy_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->cut_button))
		gtk_widget_set_sensitive(info->RawEdit->cut_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->crop_button))
		gtk_widget_set_sensitive(info->RawEdit->crop_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->del_button))
		gtk_widget_set_sensitive(info->RawEdit->del_button, FALSE);
	if(GTK_WIDGET_IS_SENSITIVE(info->RawEdit->paste_at_button))
		gtk_widget_set_sensitive(info->RawEdit->paste_at_button, FALSE);

}

  void enable_raw_edit() {

	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->start_frame_spin))
		gtk_widget_set_sensitive(info->RawEdit->start_frame_spin,TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->end_frame_spin))
		gtk_widget_set_sensitive(info->RawEdit->end_frame_spin,TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->paste_at_spin))
		gtk_widget_set_sensitive(info->RawEdit->paste_at_spin,TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->sel_start_button))
		gtk_widget_set_sensitive(info->RawEdit->sel_start_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->sel_end_button))		
		gtk_widget_set_sensitive(info->RawEdit->sel_end_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->copy_button))
		gtk_widget_set_sensitive(info->RawEdit->copy_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->cut_button))
		gtk_widget_set_sensitive(info->RawEdit->cut_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->crop_button))
		gtk_widget_set_sensitive(info->RawEdit->crop_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->del_button))
		gtk_widget_set_sensitive(info->RawEdit->del_button, TRUE);
	if(!GTK_WIDGET_IS_SENSITIVE(info->RawEdit->paste_at_button))
		gtk_widget_set_sensitive(info->RawEdit->paste_at_button, TRUE);


}

  void update_sensitive_effect_controls() {
	gint p;
	gint disable_p;
	gint params=0;

	if(info->current_effect_id>0) {
		params = vj_effect_get_num_params(info->current_effect_id);
	}

	for(p=0; p < params; p++) {
		if(p==0) { 
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p0)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p0, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p0, TRUE);		
			}
		}
		if(p==1) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p1)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p1, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p1,TRUE);	
			}
		}
		if(p==2) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p2)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p2, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p2, TRUE);
			}
		}
		if(p==3) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p3)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p3, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p3, TRUE);
			}
		}
		if(p==4) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p4)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p4, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p4,TRUE);
			}
		}
		if(p==5) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p5)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p5, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p5, TRUE);
			}
		}
		if(p==6) {
			if(!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p6)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p6, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p6, TRUE);
			}
		}
		if(p==7) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p7)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p7, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p7, TRUE);
			}
		} 
		if(p==8) {
			if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p8)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p8, TRUE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p8, TRUE);
			}
		} 

	}
	/* gray out remaining parameters */
	for(disable_p = p ; disable_p < 9; disable_p++) {
		if(disable_p==0) { 
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p0)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p0, FALSE);	
				gtk_widget_set_sensitive(info->SampleEdit->slider_p0, FALSE);
			}
		}
		if(disable_p==1) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p1)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p1, FALSE );	
				gtk_widget_set_sensitive(info->SampleEdit->slider_p1, FALSE);
			}
		}
		if(disable_p==2) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p2)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p2, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p2, FALSE);
			}
		}
		if(disable_p==3) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p3)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p3, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p3,FALSE);
			}
		}
		if(disable_p==4) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p4)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p4, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p4, FALSE);
			}
		}
		if(disable_p==5) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p5)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p5, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p5, FALSE);
			}
		}
		if(disable_p==6) {
			if(GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p6)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p6, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p6,FALSE);
			}
		}
		if(disable_p==7) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p7)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p7, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p7,FALSE);
			}
		}
		if(disable_p==8) {
			if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->spinbox_p8)) {
				gtk_widget_set_sensitive(info->SampleEdit->spinbox_p8, FALSE);
				gtk_widget_set_sensitive(info->SampleEdit->slider_p8,FALSE);
			}
		}

	}
	if(params>0) {
		update_effect_control_limits(info->SampleEdit->spinbox_p0, 0);
		}
	if(params>1){
		update_effect_control_limits(info->SampleEdit->spinbox_p1,1);

	}
	if(params>2) {
		update_effect_control_limits(info->SampleEdit->spinbox_p2,2);
	}
	if(params>3) {
		update_effect_control_limits(info->SampleEdit->spinbox_p3,3);
	}
	if(params>4) {
		update_effect_control_limits(info->SampleEdit->spinbox_p4,4);
	}
	if(params>5){
		update_effect_control_limits(info->SampleEdit->spinbox_p5,5);
	}
	if(params>6) {
		update_effect_control_limits(info->SampleEdit->spinbox_p6,6);
	}
	if(params>7) {
		update_effect_control_limits(info->SampleEdit->spinbox_p7,7);
		}
	if(params>8) {
		update_effect_control_limits(info->SampleEdit->spinbox_p8,8);
		}

}
/* v4l edit disables some button in the gui */
  void update_v4l_sampleedit_up() {
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->start_frame_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->start_frame_spin, TRUE);
	}
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->end_frame_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->end_frame_spin, TRUE);
	}
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->loop_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->loop_button, TRUE);
	}
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->noloop_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->loop_button, TRUE);
	}
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->pingpong_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->loop_button, TRUE);
	}

	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->volume_slider)) {
		gtk_widget_set_sensitive(info->SampleEdit->volume_slider,TRUE);
	}
	if (!GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->volume_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->volume_spin, TRUE);
	}

}


/* v4l edit disables some button in the gui */
  void update_v4l_sampleedit_down() {
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->start_frame_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->start_frame_spin, FALSE);
	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->end_frame_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->end_frame_spin, FALSE);
	}
	/* these are actually valid	
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->next_sample_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->next_sample_spin, FALSE);
	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->max_loops_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->max_loops_spin, FALSE);
	}
	*/
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->noloop_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->noloop_button, FALSE);
	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->loop_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->loop_button, FALSE);
	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->pingpong_button)) {
		gtk_widget_set_sensitive(info->SampleEdit->pingpong_button, FALSE);
	}
//	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->render_button)) {
//		gtk_widget_set_sensitive(info->SampleEdit->render_button, FALSE);
//	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->volume_slider)) {
		gtk_widget_set_sensitive(info->SampleEdit->volume_slider,FALSE);
	}
	if (GTK_WIDGET_IS_SENSITIVE(info->SampleEdit->volume_spin)) {
		gtk_widget_set_sensitive(info->SampleEdit->volume_spin, FALSE);
	}

}

  void update_active_entry(int num) {
	info->entry_active = num;
	if(num==1) { /* active */
		if(!GTK_TOGGLE_BUTTON(info->SampleEdit->bypass_button)->active) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info->SampleEdit->bypass_button),
				TRUE);
		}
		info->SampleEdit->bypass_entry = 1;
	}
	else {
		/* inactive, button must be up */
		if(GTK_TOGGLE_BUTTON(info->SampleEdit->bypass_button)->active) {
			gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(info->SampleEdit->bypass_button),
				FALSE);
		}
		info->SampleEdit->bypass_entry = 0;
	}

}

  void update_chain_entry(int chain_id) {
	info->chain_entry = chain_id;
			update_effect_control_values(); 	
}


  void update_effect_control(GtkWidget *widget, gint param_nr) {
	gint cur_val;

	cur_val = gtk_spin_button_get_value_as_int(GTK_SPIN_BUTTON(widget));
#ifdef LOTSOFINFO
	printf("Setting value %d\n", cur_val);
#endif
	/* set this value */
	sprintf(info->cmd_msg, "%d %d %d %d", MSG_SAMPLE_SET_EFFECT_PARAM,info->chain_entry,param_nr,cur_val);
	//write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
	vj_comm_write(info->cmd_msg);
}

  void update_slider_control(GtkWidget *widget, int param_nr) {
	int val;
	val = GTK_ADJUSTMENT(GTK_RANGE(widget)->adjustment)->value;
#ifdef LOTSOFINFO
	printf("val in slider control = %d\n",val);
#endif		
	
}


  void update_total_frames(glong n) {
	MPEG_timecode_t tc;
	char timecode[10];
	char timestr[10];

	mpeg_timecode( &tc, n, mpeg_framerate_code(
		mpeg_conform_framerate(info->fps)), info->fps);

	sprintf(timecode, "%2d:%2.2d:%2.2d:%2.2d", tc.h, tc.m, tc.s, tc.f);
	sprintf(timestr, "%06ld", n);
	
	gtk_label_set_text(GTK_LABEL(info->RawEdit->total_frames_label), timestr);
	gtk_label_set_text(GTK_LABEL(info->RawEdit->total_duration_label), timecode);
	info->total_frames = n;	

	
}

  void update_current_frame(glong n) {
	MPEG_timecode_t tc;
	char timecode[15];
	char timestr[10];
	double tf;
	double cf;

	if(info->hscale_down==1) return;

	if(info->playback_mode == VJ_PLAYBACK_MODE_SAMPLE) {
		tf = info->sample_end - info->sample_start;
		cf = (n - info->sample_start);
	}
	else {
		tf = (double) info->total_frames;
		cf = n;
	}


 	mpeg_timecode( &tc, n, mpeg_framerate_code(mpeg_conform_framerate(info->fps)),info->fps);
	sprintf(timestr, "%06ld", n);

	sprintf(timecode, "%2d:%2.2d:%2.2d:%2.2d", tc.h, tc.m, tc.s, tc.f);
	gtk_label_set_text(GTK_LABEL(info->Navigator->current_timecode_label), timecode);
	gtk_label_set_text(GTK_LABEL(info->Navigator->current_frame_label), timestr);

	info->frame_num = n;
       
	gtk_adjustment_set_value(
			GTK_ADJUSTMENT(GTK_RANGE(info->video_bar)->adjustment), 
			(100.0)*(double)(cf)/(tf));


}



void update_current_sample(gint n) {
	if(valid_mode_sample()) {
		
		info->current_sample_id = n;
		sample_description_get(); 
		sprintf(info->stat_msg, "Selected sample %d\n", n);
		gtk_text_insert(GTK_TEXT(info->status_text), NULL, NULL, NULL, info->stat_msg, -1);
		samplelist_update();	

	}
	if(valid_mode_tag()) {
		gchar tagstr[10];
		sprintf(tagstr, "%06d", n);
		gtk_label_set_text(GTK_LABEL(info->SampleEdit->tag_id), tagstr);
		info->current_sample_id = n;
		sprintf(info->stat_msg, "Selected tag %d\n", n);
		gtk_text_insert(GTK_TEXT(info->status_text), NULL, NULL, NULL, info->stat_msg, -1);
	}
}

void clear_parameters() {
	int e[10];
	int i;
	for(i=0; i < 10; i++) {
		e[i] = 0;
	}
	update_current_entry_contents(e);
}

void update_effect_parameters() {
	char cmd[MESSAGE_SIZE];
	int n;
	int req_id, params, trim, e_frame;
	int e[10];
	sprintf(cmd, "%d", MSG_REQ_GET_FULL_CHAIN);
	n = vj_comm_write(cmd);
	n = vj_comm_read(cmd);
	if(n==0) {
		sscanf(cmd, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		 &req_id,	
  		 &params,
		 &e[0],&e[1],&e[2],&e[3],&e[4],&e[5],&e[6], &e[7], &e[8], &e[9],
		 &trim,
		 &e_frame);
	

  		update_current_entry_contents( e );
	} 
}

void update_effect_chain_contents() {
	gint req_id;
	gint effects[SAMPLE_MAX_EFFECTS];
	/* read effect chain */
	char cmd[MESSAGE_SIZE];
	int n = 0;
	if(!effects) return;
	sprintf(cmd, "%d", MSG_REQ_GET_FULL_NCHAIN);
	//write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
	n = vj_comm_write(cmd);
	//read(input_pipe, info->cmd_msg , MESSAGE_SIZE);
	n = vj_comm_read(cmd);
	if(n==0) {
	sscanf(cmd, "%d %d %d %d %d %d %d %d %d %d %d",
		&req_id, &effects[0],&effects[1],&effects[2],&effects[3],
		&effects[4],&effects[5],&effects[6],&effects[7],&effects[8],
		&effects[9]);
	if(req_id==MSG_REQ_GET_FULL_NCHAIN) {
		gint entry=0;
		gtk_clist_freeze(GTK_CLIST(info->SampleEdit->effect_chain));
		for(entry=0; entry < SAMPLE_MAX_EFFECTS; entry++) {
			if(effects[entry]==-1) {
				gtk_clist_set_text(GTK_CLIST(info->SampleEdit->effect_chain),
					entry,1,"<none>");
			}
			else {
				gtk_clist_set_text(GTK_CLIST(info->SampleEdit->effect_chain),
					entry, 1, vj_effect_get_effect_descr(effects[entry]));	
			}
		}
		gtk_clist_thaw(GTK_CLIST(info->SampleEdit->effect_chain));
	}

	}
}


void update_sample_info(int sample_id) {
	MPEG_timecode_t tc;
	char framelen[10];
	char samplestr[10];
	char timecode[11];
	long len = (info->sample_end - info->sample_start);

	sprintf( framelen, "%06ld", len );
	sprintf(samplestr, "%06d", sample_id);

	gtk_label_set_text(GTK_LABEL(info->SampleEdit->sample_label), samplestr);
	mpeg_timecode( &tc, len, mpeg_framerate_code(mpeg_conform_framerate(info->fps)),info->fps);
	sprintf(timecode, "%2d:%2.2d:%2.2d:%2.2d", tc.h, tc.m, tc.s, tc.f);
	sprintf(framelen, "%06ld", len );

	gtk_label_set_text(GTK_LABEL(info->SampleEdit->duration_label), timecode);

	gtk_label_set_text(GTK_LABEL(info->SampleEdit->numframes_label), framelen);

}

void update_sample_start(glong n) {
	info->sample_start = n;
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->start_frame_spin),
		(gfloat)n);
}

void update_sample_end(glong n) {
	info->sample_end = n;
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->end_frame_spin),
		(gfloat)n);
}

void update_pattern_row(gint n) {
	MPEG_timecode_t tc;
	char timecode[15];
	char timestr[10];

	//tracker_set_patpos(info->tracker, n);
	info->current_row = n;
	//tracker_step_cursor_row(info->tracker, (n-info->tracker->patpos));
	tracker_set_patpos(info->tracker,n);
//	fprintf(stderr, "set pattern position %d\n", n);
 	mpeg_timecode( &tc, n, mpeg_framerate_code(mpeg_conform_framerate(info->fps)),info->fps);
	sprintf(timestr, "%06d", n);

	sprintf(timecode, "%2d:%2.2d:%2.2d:%2.2d", tc.h, tc.m, tc.s, tc.f);
	gtk_label_set_text(GTK_LABEL(info->Navigator->current_timecode_label), timecode);
	gtk_label_set_text(GTK_LABEL(info->Navigator->current_frame_label), timestr);


}

  void update_pattern_size(gint n) {
	tracker_update_pattern(info->tracker, n);
	info->pattern_size = n;
}

  void update_next_sample(gint id) {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->next_sample_spin),
		(gfloat)id);
	info->next_sample = id;
}

  void update_max_loops(gint nr) {
	gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->max_loops_spin),
		(gfloat)nr);
	info->max_loops = nr;
	fprintf(stderr, "Updated max loops to %d\n",nr);
}

  void update_sample_edit(glong new_start_frame, glong new_end_frame) {
  
  sprintf(info->cmd_msg, "%d %ld", MSG_CMD_SET_START_FRAME,new_start_frame);
  //write(request_pipe, info->cmd_msg ,MESSAGE_SIZE);
  vj_comm_write(info->cmd_msg);
  sprintf(info->stat_msg, "Updated sample start to frame %ld\n", new_start_frame);
  gtk_text_insert(GTK_TEXT(info->status_text), NULL,NULL,NULL, info->stat_msg,-1);
  sprintf(info->cmd_msg, "%d %ld", MSG_CMD_SET_END_FRAME,new_end_frame);
  //write(request_pipe, info->cmd_msg ,MESSAGE_SIZE);
  vj_comm_write(info->cmd_msg);
  sprintf(info->stat_msg, "Updated sample end to frame %ld\n", new_end_frame);
  gtk_text_insert(GTK_TEXT(info->status_text), NULL,NULL,NULL, info->stat_msg,-1);
  
}
  void update_sample_speed(gint n) {
	info->playback_speed = n;
	sprintf(info->stat_msg, "Speed is now %d\n",
		info->playback_speed);
	gtk_text_insert(GTK_TEXT(info->status_text),NULL,NULL,NULL,info->stat_msg,-1);
	if(valid_mode_sample) {
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->playback_speed_spin),
			(gfloat)n);
	}
}

  void update_effect_chain(gint n) {
	if (n) {
		sprintf(info->stat_msg, "Effect Chain Enabled\n");
	}
	else {
		sprintf(info->stat_msg, "Effect Chain Disabled\n");
	}
	gtk_text_insert(GTK_TEXT(info->status_text),NULL,NULL,NULL,info->stat_msg,-1);	
	info->effect_chain = n;
}

  void update_sample_play(int mode) {
	if(mode == VJ_PLAYBACK_MODE_SAMPLE) {
		//disable_raw_edit();
	}
	if(mode == VJ_PLAYBACK_MODE_PLAIN) {
	}
	if(mode == VJ_PLAYBACK_MODE_TAG) {
	}
	if(mode == VJ_PLAYBACK_MODE_PATTERN) {
	}	
	info->playback_mode = mode;
}

  void update_looptype(int num) {
	info->looptype=num;
	switch(num) {
		case 0 : gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(
				info->SampleEdit->noloop_button), TRUE);
			break;
		case 1 : gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(
				info->SampleEdit->loop_button), TRUE);
			break;
		case 2: gtk_toggle_button_set_active(GTK_TOGGLE_BUTTON(
				info->SampleEdit->pingpong_button), TRUE);
			break;
	}
}

  void update_pattern_play(int num) {
	if(num==0) {
		sprintf(info->stat_msg, "Disabled Pattern Play\n");
	}
	else if(num==2) {
		sprintf(info->stat_msg, "Enabled Pattern Play\n");
		disable_raw_edit();
	}
	gtk_text_insert(GTK_TEXT(info->status_text),NULL,NULL,NULL,info->stat_msg,-1);
}

void update_vscrollbar( Tracker *t, int patpos, int patlen, int disprows) {

}

void update_hscrollbar( Tracker *t, int leftchan, int numchans, int dispchans) {

}

void update_mainmenu_blockmark( Tracker *t, int state ) {

}

void on_vscroll_changed( GtkAdjustment *adjustment, gpointer user_data) {

}

void on_hscroll_changed( GtkAdjustment *adjustment, gpointer user_data) {

}

  void on_videobar_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if ( info->hscale_down==1 ) {
	    char timestr[10];

 	    gint val = GTK_ADJUSTMENT(adjustment)->value;
 	    gint nframe;

	    if(info->playback_mode==VJ_PLAYBACK_MODE_SAMPLE) {
	        nframe  = val * ((info->sample_end - info->sample_start) / 100.0) + info->sample_start;
		sprintf(timestr, "%06d", nframe);
  	 	sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_FRAME, nframe);

	    }
            else {
	       nframe = val * (info->total_frames / 100.0);
	       sprintf(timestr, "%06d", nframe);
	       sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_FRAME, nframe);

	    }
	    if (nframe != info->frame_num) {
            gtk_label_set_text(GTK_LABEL(info->Navigator->current_frame_label), timestr);
  	    vj_comm_write(info->cmd_msg);
		}
	}
}

  int valid_mode_tag() {
	if(info->playback_mode == VJ_PLAYBACK_MODE_TAG) return 1;
	return 0;
}
  int valid_mode_sample() {
	if(info->playback_mode == VJ_PLAYBACK_MODE_SAMPLE ) return 1;
	return 0;	
}
  int valid_mode_pattern() {
	if(info->playback_mode == VJ_PLAYBACK_MODE_PATTERN) return 1;
	return 0;
}


  void on_slider_changed( GtkAdjustment *adjustment, gint param_nr) {
	gint val;
	
	val = (gint) ( ((GTK_ADJUSTMENT(adjustment))->value *
		vj_effect_get_max_value(info->current_effect_id,param_nr))/100);
#ifdef LOTSOFINFO
	printf("Setting slider val %d on entry %d, param %d\n",val,info->chain_entry,param_nr);
#endif
	sprintf(info->cmd_msg, "%d %d %d %d", MSG_SAMPLE_SET_EFFECT_PARAM, info->chain_entry, param_nr,val);
	//write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
	vj_comm_write(info->cmd_msg);
}

void update_sample_render_list() {
	char msg[MESSAGE_SIZE];
	int i,c;
	sprintf(msg, "%d", MSG_REQ_SAMPLE_GET_RENDER_LIST);
	vj_comm_write(msg);
	vj_comm_read(msg);
	sscanf(msg, "%d %d", &c,&i);
	if(c==MSG_REQ_SAMPLE_GET_RENDER_LIST) {
		int entries;
		strtok(msg," ");
		strtok(NULL," ");	
		gtk_clist_freeze(GTK_CLIST(info->render->list));
		
		for(entries=0; entries < 10; entries++) {
			char *start = strtok(NULL," ");
			char *end = strtok(NULL," ");
			if(entries==0) {
				gchar text[25];
				sprintf(text, "Original sample");	
				gtk_clist_set_text(GTK_CLIST(info->render->list),entries,1,text);
			}
			else {
			if( (strcmp(start,"0")==0 && strcmp(end,"0")==0) || (start==NULL || end==NULL )) {
				gchar text[15];		
				sprintf(text, "Empty");
				gtk_clist_set_text(GTK_CLIST(info->render->list),
					entries,1,text);
			}
			else {
				gchar text[25];
				sprintf(text,"Start: %s End %s",start,end);
				gtk_clist_set_text(GTK_CLIST(info->render->list),entries,1,text);
			}
			}
		}
		gtk_clist_thaw(GTK_CLIST(info->render->list));
 
	}
	
}

void on_slider_p0_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,0);
}

  void on_slider_p1_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,1);
}
  void on_slider_p2_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,2);
}
  void on_slider_p3_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,3);
}
  void on_slider_p4_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,4);
}
  void on_slider_p5_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,5);
}
  void on_slider_p6_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,6);
}
  void on_slider_p7_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,7);
}

  void on_slider_p8_changed( GtkAdjustment *adjustment, gpointer user_data) {
	if(info->SampleEdit->slider_down) on_slider_changed(adjustment,8);
}

  void update_current_entry_contents( gint *effect_arg) {
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p0),
				effect_arg[0]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p0)->adjustment),
				effect_arg[0]
	);
		
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p1),
				effect_arg[1]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p1)->adjustment),
				effect_arg[1]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p2),
				effect_arg[2]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p2)->adjustment),
				effect_arg[2]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p3),
				effect_arg[3]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p3)->adjustment),
				effect_arg[3]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p4),
				effect_arg[4]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p4)->adjustment),
				effect_arg[4]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p5),
				effect_arg[5]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p5)->adjustment),
				effect_arg[5]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p6),
				effect_arg[6]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p6)->adjustment),
				effect_arg[6]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p7),
				effect_arg[7]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p7)->adjustment),
				effect_arg[7]
	);
			
	gtk_spin_button_set_value(
		GTK_SPIN_BUTTON(info->SampleEdit->spinbox_p8),
				effect_arg[8]);
		gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE
				(info->SampleEdit->slider_p8)->adjustment),
				effect_arg[8]
	);
}
/* move status to some other class file */
  void sample_description_get() {
	gchar sample_descr[150];
	gint id=0;

	sprintf(info->cmd_msg, "%d", MSG_REQ_GET_SAMPLEDESCR);
	//write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
	vj_comm_write(info->cmd_msg);
	//read(input_pipe, info->cmd_msg, MESSAGE_SIZE);
	vj_comm_read(info->cmd_msg);
	sscanf(info->cmd_msg, "%d %s", &id, sample_descr);
	if(id==MSG_REQ_GET_SAMPLEDESCR) {
		GtkWidget *box  = lookup_widget(Sample_window, "SE_description");
		gtk_entry_set_text(GTK_ENTRY(box), sample_descr);
	}
	else {
	}

}
void status_sample_changed(char *str) {
	gint sample_info[11];
	gint effect_info[6];
	//gint effect_arg[10];
	gint entry;
	gint cf;
	gint skip;
	gint changed=0;
	gint nr_of_samples = 0;
	gint update_sampleinfo = 0;
	gint current_render_entry=0;
	gint r_changed = 0;
	gint chain_update = 0;
	gint control_update = 0;
	gint param_update = 0;
	sscanf(str, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		//&skip,
		&cf,
		&current_render_entry,
		&r_changed,
		&sample_info[0],	/* sample id */
		
		&sample_info[1], /* start */
		&sample_info[2], /* end */
		&sample_info[3], /* speed */
		&sample_info[4], /* looptype */
		&sample_info[5], /* max loops */
		&sample_info[6], /* max loops 2 */
		&sample_info[7], /* next sample */
		&sample_info[8], /* depth */
		&sample_info[9], /* playmode */
		&sample_info[10], /* audio volume */
		&entry,		/* current chain entry */
		&changed,	/* re-read effect chain on 1*/
		&effect_info[0], /* effect_id */
		&effect_info[1], /* enabled ? */
		&effect_info[2], /* frame offset */
		&effect_info[3], /* frame trimmer */
		&effect_info[4], /* source type */
		&effect_info[5],	/* channel */
		&nr_of_samples
	);

	if(r_changed==1) {
		update_sample_render_list();
	}
	if(current_render_entry != info->active_render_entry) {
		info->active_render_entry = current_render_entry;
	}
	if(nr_of_samples != info->total_samples) {
		info->total_samples = nr_of_samples;
		if(nr_of_samples>0) {
			gtk_clist_clear(GTK_CLIST(info->SampleList));
			get_all_samples(nr_of_samples);
			get_all_tags(info->total_tags);
		}
	}
		/* see if something changed */
	if( sample_info[0] != info->current_sample_id) {
		info->chain_entry = -1;
		update_sampleinfo = 1;
		update_current_sample( sample_info[0] );
	}

	if( sample_info[1] != info->sample_start) {
		update_sample_start( sample_info[1] );
		update_sampleinfo = 1;
	}
	if( sample_info[2] != info->sample_end) {
		update_sample_end( sample_info[2] );
		update_sampleinfo = 1;
	}

	if (cf != info->frame_num) update_current_frame(cf);
	

	if( sample_info[3] != info->playback_speed) update_sample_speed( sample_info[3] );

	if( sample_info[4] != info->looptype) update_looptype( sample_info[4] );
	if( sample_info[5] != info->max_loops) update_max_loops( sample_info[5] );

	if( sample_info[6] != info->next_sample) update_next_sample( sample_info[6] );

	if( changed == 1) {
		//gtk_notebook_set_page(GTK_NOTEBOOK(info->SampleEdit->sample_controls),2);
		clear_parameters();
		chain_update = 1;
		param_update = 1;
				//update_current_entry_contents(effect_arg);
	}

	if( entry != info->chain_entry) {
		info->chain_entry = entry;
		//gtk_notebook_set_page(GTK_NOTEBOOK(info->SampleEdit->sample_controls),2);
		update_chain_entry( entry );
		clear_parameters();
		//update_effect_chain_contents(); 
		chain_update = 1;
		param_update = 1;
		//update_effect_parameters(); 
	}	
	if( effect_info[0] != info->current_effect_id ) {
		//gtk_notebook_set_page(GTK_NOTEBOOK(info->SampleEdit->sample_controls),2);
		info->current_effect_id = effect_info[0];
		
		control_update = 1;
		//update_sensitive_effect_controls();
		chain_update = 1;
		//update_effect_chain_contents();
		//update_current_entry_contents( effect_arg );
	}

	//if( effect_info[1] != info->effect_chain) {
		//update_effect_chain( effect_info[1] );
		if(info->SampleEdit->bypass_entry != effect_info[1]) {
			info->SampleEdit->bypass_update = 1;	
			update_active_entry( effect_info[1]);
			info->SampleEdit->bypass_update = 0;
		}
	//}


	//if( info->SampleEdit->slider_down == 0 ) { /* is chain enabled ? */
	//	}	
	if( effect_info[4] != info->SampleEdit->source_number) {
		info->SampleEdit->source_number = effect_info[4];
		//gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->source), effect_info[4]);
		switch(effect_info[4]) {
			case 0:
				gtk_entry_set_text(GTK_ENTRY(
					GTK_COMBO(info->SampleEdit->source)->entry), "SAMPLE");
				break;
			case 1:
			case 2:
			case 3:
				gtk_entry_set_text(GTK_ENTRY(
					GTK_COMBO(info->SampleEdit->source)->entry), "TAG");
				break;
		}
	}

	if( effect_info[5] != info->SampleEdit->channel_number) {
		info->SampleEdit->channel_number = effect_info[5];
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->channel), effect_info[5]);
	}

	if(update_sampleinfo) {
		update_sample_info(info->current_sample_id);
		//update_effect_chain_contents();
	}
	if(chain_update) update_effect_chain_contents();
	if(control_update) update_sensitive_effect_controls();

	if(param_update) update_effect_parameters();

}

void status_plain_changed(char *str) {
	gint input[8];
	gfloat fps=0;
	

	
	sscanf( str, "%d %d %d %d %d %f %d %d %d %d",
		//&skip,
		 &input[0], &input[1], &input[2], &input[3],
		&input[4], &fps, &input[5], &input[6], &input[7], &input[8]);

	if(input[2] != info->total_frames) update_total_frames( input[2] );

	if(input[1] != info->frame_num) update_current_frame( input[1] );
	
	if(info->fps != fps) info->fps = fps;

	if (input[6] != info->total_samples || input[7] != info->total_tags) {
		info->total_samples = input[6];
		info->total_tags = input[7];
		gtk_clist_clear(GTK_CLIST(info->SampleList));
		if(input[6]>0) get_all_samples(input[6]);
		if(input[7]>0) get_all_tags(input[7]);
	}
	/* implement vj-tags list */
}

void status_tag_changed(char *str) {
	gint input[8];
	//gint effect_arg[10];
	gint effect_info[6];
	gint entry=0;
	gint changed=0;
	gint nr_of_tags=0;
	sscanf( str, "%d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d %d",
		//&skip,
		&input[0], /* id */
		&input[1], /* next id */
		&input[2], /* source type */
		&input[3], /* index */
		&input[4], /* depth */
		&input[5], /* active */
		&input[6], /* source */
		&input[7], /* video channel */
		&entry,
		&changed,
		&effect_info[0], /* effect_id */
		&effect_info[1], /* enabled ? */
		&effect_info[2], /* frame offset */
		&effect_info[3], /* frame trimmer */
		&effect_info[4], /* source type */
		&effect_info[5], /* channel */
/*
		&effect_arg[0],
		&effect_arg[1],
		&effect_arg[2],
		&effect_arg[3],
		&effect_arg[4],
		&effect_arg[5],
		&effect_arg[6],
		&effect_arg[7],
		&effect_arg[8],
		&effect_arg[9],*/
		&nr_of_tags 
		);
	
	if(nr_of_tags != info->total_tags) {
		info->total_tags = nr_of_tags;
		gtk_clist_clear(GTK_CLIST(info->SampleList));
		if(info->total_samples>0) get_all_samples(info->total_samples);
		if(nr_of_tags>0) get_all_tags(nr_of_tags );
	}

	/*
	if( input[5] != info->SampleEdit->activate_tag) {
		info->SampleEdit->activate_tag = input[5];
	}
	*/
	if(info->current_sample_id != input[0]) {
		info->chain_entry=-1;
		update_current_sample(input[0]);
		update_effect_chain_contents();
	}

	if( entry != info->chain_entry) {
		update_chain_entry( entry );
		clear_parameters();
		update_effect_chain_contents();
		update_effect_parameters() ;
	}	

	if( changed == 1 ) {
		clear_parameters();
		update_effect_chain_contents();
		update_effect_parameters();
	}

	if (effect_info[0] != info->current_effect_id) {
		info->current_effect_id = effect_info[0];
		update_sensitive_effect_controls();
		//update_current_entry_contents( effect_arg );
		update_effect_chain_contents();
	}

	if(info->SampleEdit->bypass_entry != effect_info[1]) {
			info->SampleEdit->bypass_update = 1;	
			update_active_entry( effect_info[1]);
			info->SampleEdit->bypass_update = 0;
		}

	if( effect_info[4] != info->SampleEdit->source_number) {
		info->SampleEdit->source_number = effect_info[4];
		gtk_entry_set_text(GTK_ENTRY(
			GTK_COMBO(info->SampleEdit->source)->entry), ( effect_info[4]==0 ? "SAMPLE" : "TAG" ));

		//gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->source), effect_info[4]);
	}

	if( effect_info[5] != info->SampleEdit->channel_number) {
		info->SampleEdit->channel_number = effect_info[5];
		gtk_spin_button_set_value(GTK_SPIN_BUTTON(info->SampleEdit->channel), effect_info[5]);
	}

	if( info->SampleEdit->slider_down == 0 ) { /* is chain enabled ? */
	}	
	
	

}

void status_pattern_changed(char *str) {
	int cur_row, cur_length, cur_col, cur_speed,cur_looptype,cur_state, preview;
	int mode = 0;

	sscanf(str, "%02d %06d %02d %06d %1d %02d %1d %1d",
		&mode,
		&cur_row,
		&cur_col,
		&cur_length,
		&cur_state,
		&cur_speed,
		&cur_looptype,
		&preview
		);
	fprintf(stderr, "Cowardly refusing to play a pattern\n");
	exit(0);
	
	if ( cur_row != info->current_row) {
		update_pattern_row( cur_row  );
	}
	if ( cur_length != info->pattern_size) {
		update_pattern_size(cur_length);
	}
	if ( cur_col != info->current_col) {
		info->current_col = cur_col;
	}
	if ( preview != info->pattern_preview_mode) {
		switch(preview) {
			case 0: sprintf(info->stat_msg, "Pattern Effect Preview Switched OFF\n"); break;
			case 1: sprintf(info->stat_msg, "Pattern Effect Preview current Chain Entry\n");break;
			case 2: sprintf(info->stat_msg, "Pattern Effect Preview All Entries\n");break;
			default:
				sprintf(info->stat_msg, "Uknown Preview Mode\n"); break;
		}
		gtk_text_insert(GTK_TEXT(info->status_text),NULL,NULL,NULL,info->stat_msg,-1);
		info->pattern_preview_mode = preview;
	}

}

/*
void create_small_pixmap() {
	GdkPixbufLoader *loader;
	FILE *file;
	gchar template[10];
	if(!valid_mode_sample()) return;

	sprintf(template, "sample-%04d", info->current_sample_id);
	sprintf(info->cmd_msg, "%d", MSG_REQ_SCREENSHOT, template);
	write(request_pipe, info->cmd_msg, MESSAGE_SIZE);

	read(input_pipe, info->cmd_msg, MESSAGE_SIZE);
	sscanf(info->cmd_msg, "%d %d", id,res);
	if(id==MSG_REQ_SCREENSHOT && res == 1) {
		GdkPixbuf *pixbuf = gdk_pixbuf_new_from_file(template);
		if(pixbuf) {
			
			gdk_pixbuf_unref(pixbuf);
		}
	}
}
*/
void process_status_information(gpointer data, gint fd, GdkInputCondition
	condition) {
	char status_msg[MESSAGE_SIZE*2];
	char block[MESSAGE_SIZE*2];
	gint n;
	gint mode;
	gint effects_enabled;
	bzero(block,MESSAGE_SIZE*2);	
	n = vj_comm_status_read(status_msg);
	//if(n < vj_comm_read(status_msg) )
	if (n<0) {
		printf("Nothing in pipe\n");
		vj_comm_exit();
		return;
	}	
	sscanf(status_msg, "%d %d", &mode, &effects_enabled);
	if(mode != info->playback_mode) {
		/* enable / disable panels */
		if(mode == VJ_PLAYBACK_MODE_PLAIN) {	
			clear_effect_chain(); clear_render_list();
		}
		if(mode == VJ_PLAYBACK_MODE_TAG) {
			clear_render_list();
		}
	}
	
	if(effects_enabled != info->top_effects_toggle) {
		info->top_effects_toggle = effects_enabled;
	}
	strncpy(block, status_msg+3, strlen(status_msg)-3);
	switch(mode) {
		case VJ_PLAYBACK_MODE_SAMPLE:
			info->playback_mode = VJ_PLAYBACK_MODE_SAMPLE;
			status_sample_changed(block);
			break;
		case VJ_PLAYBACK_MODE_TAG:
			info->playback_mode = VJ_PLAYBACK_MODE_TAG;
			status_tag_changed(block);
			break;
		case VJ_PLAYBACK_MODE_PLAIN:
			info->playback_mode = VJ_PLAYBACK_MODE_PLAIN;
			status_plain_changed(block);
			break;
		case VJ_PLAYBACK_MODE_PATTERN:
			info->playback_mode = VJ_PLAYBACK_MODE_PATTERN;
			status_pattern_changed(block);
			break;

	}

	/*
	if ( info->slider_pause ) {
		info->slider_pause--;
	}
	else {
	
		if (!info->hscale_down) {
			 gtk_adjustment_set_value(
				GTK_ADJUSTMENT(GTK_RANGE(info->video_bar)->adjustment), 
				(100.0)*(double)((double)info->frame_num)/((double)
				info->total_frames));
			
		}
	}
	*/
}



