#include "vj-effectctrl.h"
#include "vj-global.h"
#include "vj-comm.h"
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <glib.h>
extern int max_effects; /* in vj-comm.c */
/* hardcoded for now (not recommended ...)*/
void vj_effects_sort(vj_effect_data *ved, int effect_nr) {
	gchar *text[0];
	vjcomm *info = vj_comm_get_info();

	if (effect_nr>0 && effect_nr<26) {
		info->video_effects = g_list_append(
				info->video_effects,
				g_strdup(ved->description));
		text[0] = g_strdup(ved->description);
		if(text[0]) {
			gtk_clist_append(
				GTK_CLIST(info->SampleEdit->video_effects),
				text
			);
		}
	}
	if (effect_nr>26 ) {
		info->image_effects = g_list_append(
				info->image_effects,
				g_strdup(ved->description));
		text[0] = g_strdup(ved->description);
		if(text[0]) {
			gtk_clist_append(
				GTK_CLIST(info->SampleEdit->image_effects),
				text
			);
		}
	}
}

gint vj_effect_get_extra_frame(gint effect_id) {
	vj_effect_data *ved;
	vjcomm *info = vj_comm_get_info();

	ved = g_list_nth_data(info->effects,effect_id);
	if(ved==NULL) return 0;
	return ved->extra_frame;
}

gint vj_effect_get_effect_nr(gchar *effect_description) {
	gint i;
	vj_effect_data *ved;
	vjcomm *info = vj_comm_get_info();

	/* need to find effect_id by description (text). */
	for(i=1; i <= max_effects; i++) {
		ved = g_list_nth_data(info->effects, i);	
		if(ved==NULL) {
			return 0;
		}
		if(g_strcasecmp(ved->description, effect_description)==0) return i;
	}
	return 0;
}


gchar *vj_effect_get_effect_descr(int effect_id) {
	vj_effect_data *ved;
	vjcomm *info = vj_comm_get_info();

	ved = g_list_nth_data(info->effects,effect_id);
	return ved->description;
}

vj_effect_data *vj_effect_new(gchar *name, gint q_nframe) {
	//vj_effect_data *ved = (vj_effect_data*)malloc(sizeof(vj_effect_data));
	vj_effect_data *ved = g_new( vj_effect_data, 1);
	vjcomm *info = vj_comm_get_info();

	if(!ved) {
		fprintf(stderr, "Malloc error. Out of memory ?\n");
		return NULL;
	}
	sprintf(ved->description, "%s", name);
	ved->extra_frame = q_nframe;
	ved->minimum_values = NULL;
	ved->maximum_values = NULL;
	ved->default_values = NULL;

	return ved;
}

gint vj_effects_start() {
		fprintf(stderr, "\n");
	return 1;
}	

gint vj_effect_get_num_params(gint effect_id) {
	vjcomm *info = vj_comm_get_info();

	vj_effect_data *ved;
	ved=g_list_nth_data(info->effects, effect_id);
	if(ved==NULL) return -1;
	return g_list_length(ved->default_values);
}

gint vj_effect_get_default(gint effect_id, gint param_nr) {
	vj_effect_data *ved;
	vjcomm *info = vj_comm_get_info();

	ved = g_list_nth_data(info->effects, effect_id);
	if (ved==NULL) return -1;
	if (g_list_length(ved->default_values) >= param_nr) {
		return GPOINTER_TO_INT(g_list_nth_data(ved->default_values, param_nr));
	}
	return -1;
}
gint vj_effect_get_max_value(gint effect_id, gint param_nr) {
	vjcomm *info = vj_comm_get_info();

	vj_effect_data *ved = g_list_nth_data(info->effects,effect_id);

	if(ved==NULL) return 0;
	if(g_list_length(ved->maximum_values) >= param_nr) {
		return GPOINTER_TO_INT(g_list_nth_data(ved->maximum_values, param_nr));
	}
	return 0;
}

gint vj_effect_get_min_value(gint effect_id, gint param_nr) {

	vjcomm *info = vj_comm_get_info();
	vj_effect_data *ved = g_list_nth_data(info->effects, effect_id);

	if(ved==NULL) return 0;
	if (g_list_length(ved->minimum_values) >= param_nr) {
		return GPOINTER_TO_INT(g_list_nth_data(ved->minimum_values,param_nr));
	}
	return 0;
}

gint vj_effects_stop() {
	return 1;
}

