#ifndef VJ_EFFECTS_H
#define VJ_EFFECTS_H

#include <gtk/gtk.h>
#include "vj-global.h"


typedef struct vj_effect_data_t {
	GList *default_values;		
	GList *minimum_values;		
	GList *maximum_values;
	char description[100];
	gint id;
	gint extra_frame;
} vj_effect_data;

/* requests all effects from pipe and initializes containers */
gint vj_effects_start();
vj_effect_data *vj_effect_new(gchar *name, gint q_nframe) ;
void vj_effects_sort(vj_effect_data *ved, int effect_nr);
gint vj_effect_get_effect_nr(gchar *effect_description);

gint vj_effect_get_extra_frame(int effect_id);

gchar *vj_effect_get_effect_descr(int effect_id);

/* set this value */
gint vj_effect_set_param(gint param_nr, gint chain_index, gint value);

/* request pipe and retrieve an effect parameter */
gint vj_effect_get_param(gint chain_index, gint param_nr);

/* look in container and set default, write to pipe */
gint vj_effect_set_default(gint effect_id, gint chain_index, gint param_nr);

/* look in container and return default */
gint vj_effect_get_default(gint effect_id, gint param_nr);

gint vj_effect_get_max_value(gint effect_id, gint param_nr);

gint vj_effect_get_min_value(gint effect_id, gint param_nr);

gint vj_effect_get_num_params(gint effect_id);

/* shutdown and empty */
gint vj_effects_stop();

#endif
