/* (C) Niels Elburg <elburg@hio.hen.nl>
 * 
 * This program is free software you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 *
 */

/* 
 * PatternEditor lives here; all keypresses are sent down the drain with parameters 
 * Should be able to load multiple keyboard configurations and configfile
 *
 * 
 */

#include <gdk/gdk.h>
#include <gdk/gdkkeysyms.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include "vj-comm.h"
#include "vj-patternctrl.h"
gboolean track_edit_handle_key(vjcomm *info, int shift, int ctrl, int alt,
	guint32 keyval, gboolean pressed) {
	//vjcomm *info = vj_comm_get_info();

	Tracker *t = info->tracker;
	gboolean retval=FALSE;
	
	switch(keyval) {
		/*
		case GDK_Escape:
			if (!valid_mode_pattern) {
				sprintf(info->cmd_msg, "%d", MSG_CMD_PATTERN_PLAY);
				write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
				sprintf(info->stat_msg, "Switching playmode to Pattern\n");
			}
			else  {
				sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_SAMPLE,
					info->current_sample_id);
				write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
				sprintf(info->stat_msg, "Switched playmode, playing Sample %d\n",
					info->current_sample_id);	
			}
			gtk_text_insert(GTK_TEXT(info->status_text),NULL,NULL,NULL,info->stat_msg, -1);
			retval = TRUE;
			break;
		*/
		case GDK_Up:
			if (!ctrl && !alt && !shift) {
				sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
					(t->patpos - 1), t->cursor_ch);
				vj_comm_write( info->cmd_msg );
			}
			retval = TRUE;
			break;
		case GDK_Down:
			if (!ctrl && !alt && !shift) {
				sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
					(t->patpos + 1), t->cursor_ch);
				vj_comm_write( info->cmd_msg);
			}
			retval = TRUE;
			break;
		case GDK_KP_Down:
			sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
					(t->patpos + (gint)info->fps), t->cursor_ch);
			vj_comm_write( info->cmd_msg );
			retval = TRUE;
			tracker_redraw(t);
			break;
		case GDK_KP_Up:
			sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
				(t->patpos - (gint)info->fps), t->cursor_ch);
			vj_comm_write( info->cmd_msg );
			retval = TRUE;
			tracker_redraw(t);
			break;
		case GDK_KP_4:
			sprintf(info->cmd_msg, "%d", MSG_CMD_PLAY_BACKWARD);
			vj_comm_write( info->cmd_msg );
			retval = TRUE;
			break;
		case GDK_KP_6:
			sprintf(info->cmd_msg, "%d", MSG_CMD_PLAY_FORWARD);
			vj_comm_write( info->cmd_msg );
			retval = TRUE;
			break;
		case GDK_KP_5:
			sprintf(info->cmd_msg, "%d", MSG_CMD_PLAYPAUSE);
			vj_comm_write(info->cmd_msg);
			retval = TRUE;
			break;
		case GDK_KP_7:
			sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_FRAME, t->patpos - 1);
			vj_comm_write(info->cmd_msg);
			break;
		case GDK_KP_9:
			sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_FRAME, t->patpos + 1);
			vj_comm_write(info->cmd_msg);
			break;
		case GDK_KP_1:
			sprintf(info->cmd_msg, "%d", MSG_CMD_SKIPTOSTART);
			vj_comm_write(info->cmd_msg);
			break;
		case GDK_KP_3:
			sprintf(info->cmd_msg, "%d", MSG_CMD_SKIPTOEND);	
			vj_comm_write(info->cmd_msg);
			break;
		case GDK_Home:
			sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
					1, (shift ? 0 : t->cursor_ch) );
			vj_comm_write(info->cmd_msg);
			retval = TRUE;
			break;
		case GDK_KP_Multiply:
			sprintf(info->cmd_msg, "%d %d", MSG_CMD_SET_LOOPTYPE,1);
			vj_comm_write(info->cmd_msg);
			retval = TRUE;
			break;
		case GDK_End:
			sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,
					info->pattern_size, (shift ? 0 : t->cursor_ch) );
			vj_comm_write(info->cmd_msg);
			retval = TRUE;
			break;
		case GDK_Right:
			tracker_step_cursor_item(t, 1);
			tracker_redraw(t);
			retval = TRUE;
			break;
		case GDK_Left:
			tracker_step_cursor_item(t, -1);
			tracker_redraw(t);
			retval = TRUE;
			break;
		/*
		case GDK_space:
		
		case GDK_KP_Space:
			if (shift) {
				switch(t->cursor_item) {
					case 1:
						if(t->cursor_ch == info->PatternEdit->column) {
							sprintf(info->cmd_msg, "%d %d %d %d",
								MSG_CMD_PATTERN_MULTI_SET_OFFSET,
								info->PatternEdit->row,
								t->patpos,
								t->cursor_ch);
							write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
						}
						break;
					case 2:
						if(t->cursor_ch == info->PatternEdit->column) {
							sprintf(info->cmd_msg, "%d %d %d %d",
								MSG_CMD_PATTERN_MULTI_SET_BLEND,
								info->PatternEdit->row,
								t->patpos,
								t->cursor_ch);
							write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
						}
						break;
					case 3:
						if(t->cursor_ch == info->PatternEdit->column) {
							sprintf(info->cmd_msg, "%d %d %d %d",
								MSG_CMD_PATTERN_MULTI_SET_BLENDP,
								info->PatternEdit->row,
								t->patpos,t->cursor_ch);
							write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
						}
						break;
					case 5:
						if(t->cursor_ch == info->PatternEdit->column) {
							sprintf(info->cmd_msg, "%d %d %d %d",
								MSG_CMD_PATTERN_MULTI_SET_OPERATION,
								info->PatternEdit->row,
								t->patpos,
								t->cursor_ch);
							write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
						}
						break;
					case 6:
						if(t->cursor_ch == info->PatternEdit->column) {
							sprintf(info->cmd_msg , "%d %d %d %d",
								MSG_CMD_PATTERN_MULTI_SET_ONOFF,
								info->PatternEdit->row,
								t->patpos,
								t->cursor_ch);
							write(request_pipe,info->cmd_msg,MESSAGE_SIZE);
						}
						break;
				}
			}
			else {
				switch(t->cursor_item) {
					case 0: 
						sprintf(info->cmd_msg, "%d %d %d %d",
							MSG_PATTERN_ADD_SAMPLE,
							t->patpos,
							t->cursor_ch,
							info->current_sample_id);
						write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
						break;
					case 1:
					case 2:
					case 3:
					case 5:
						info->PatternEdit->row = t->patpos;
						info->PatternEdit->column = t->cursor_ch;
						break;
					case 6:
						info->PatternEdit->row = t->patpos;
						info->PatternEdit->column = t->cursor_ch;
						sprintf(info->cmd_msg , "%d %d %d", MSG_CMD_PATTERN_TOGGLE_CHAIN,
							t->patpos, t->cursor_ch);
						write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
					break;

				}	
			}
			tracker_redraw_current_row(t);
			break;
		case GDK_Delete:
			if (shift) {
				sprintf(info->cmd_msg, "%d %d", MSG_CMD_CLEAR_COLUMN, t->cursor_ch);
			}
			else {
				sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_CLEAR_ENTRY, t->patpos,
					t->cursor_ch);
			}
			write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
			tracker_redraw_current_row(t);
			retval = TRUE;
			break;
		case GDK_Insert:
			break;
		case GDK_equal:
			switch(t->cursor_item) {
				case 0:	
					sprintf(info->cmd_msg, "%d %d %d %d",
						MSG_CMD_PATTERN_INCREASE_SAMPLE,
						t->patpos,
						t->cursor_ch,
						1);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					break;
				case 1:
					sprintf(info->cmd_msg, "%d %d %d %d", MSG_CMD_PATTERN_INCREASE_OFFSET,	
						t->patpos,t->cursor_ch,1);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					break;
				case 2:
					sprintf(info->cmd_msg, "%d %d %d", 
						MSG_REQ_PATTERN_GET_BLENDTYPE,
						t->patpos, t->cursor_ch);	
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					read(input_pipe, info->cmd_msg, MESSAGE_SIZE);
					sscanf(info->cmd_msg, "%d %d", &val1 , &val2);
					if (val1==MSG_REQ_PATTERN_GET_BLENDTYPE) {
						val2++;
						if(val2>=19) val2=1;
						if(val2 < 0) val2=19;
						sprintf(info->cmd_msg, "%d %d %d %d %d",
							MSG_CMD_PATTERN_SET_BLEND,
							val2,
							t->cursor_ch,
							t->patpos,
							0);
						write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					}
					break;
				case 3:
					sprintf(info->cmd_msg, "%d %d %d", MSG_REQ_PATTERN_GET_BLENDPARAM,
						t->patpos,t->cursor_ch);
					write(request_pipe,info->cmd_msg,MESSAGE_SIZE);
					read(input_pipe, info->cmd_msg, MESSAGE_SIZE);
					sscanf(info->cmd_msg, "%d %d", &val1, &val2);
					if(val1==MSG_REQ_PATTERN_GET_BLENDPARAM) {
						val2++;
						if(val2 > 100) val2 = 0;
						if(val2 < 0) val2 = 100;
						sprintf(info->cmd_msg, "%d %d %d %d",
							MSG_CMD_PATTERN_SET_BLEND_PARAM,
							val2,
							t->cursor_ch,
							t->patpos);
						write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
					}

					break;
				case 4:
					sprintf(info->cmd_msg, "%d %d %d %d",
						MSG_CMD_PATTERN_INCREASE_CHAIN,
						t->patpos, t->cursor_ch, 1);	
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);

					break;
				case 5:		
					sprintf(info->cmd_msg, "%d %d %d %d",
						MSG_CMD_PATTERN_INCREASE_OPERATION,
						t->patpos, t->cursor_ch, 1);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);

					break;
											
			}
			tracker_redraw_current_row(t);
			retval = TRUE;
			break;	
		case GDK_minus:
			switch(t->cursor_item) {
				case 0:
					sprintf(info->cmd_msg, "%d %d %d %d",
						MSG_CMD_PATTERN_INCREASE_SAMPLE,t->patpos,t->cursor_ch,-1);
					write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
					break;
				case 1:	
					sprintf(info->cmd_msg, "%d %d %d %d", MSG_CMD_PATTERN_INCREASE_OFFSET,
						t->patpos, t->cursor_ch, -1);			
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					break;

				case 2: 
					sprintf(info->cmd_msg, "%d %d %d", MSG_REQ_PATTERN_GET_BLENDTYPE, 
						t->patpos, t->cursor_ch);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					read(input_pipe, info->cmd_msg,MESSAGE_SIZE);
					sscanf(info->cmd_msg, "%d %d", &val1, &val2);
					if(val1==MSG_REQ_PATTERN_GET_BLENDTYPE) {
						val2--;
						if(val2>=19) val2 = 19;
						if(val2 < 0) val2 = 0;
						sprintf(info->cmd_msg, "%d %d %d %d %d",
							MSG_CMD_PATTERN_SET_BLEND,
							t->cursor_ch ? val2:0,
							t->cursor_ch,
							t->patpos,
							0);
						write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					}
					break;
				case 3: 
					sprintf(info->cmd_msg, "%d %d %d", MSG_REQ_PATTERN_GET_BLENDPARAM,
						t->patpos,t->cursor_ch);
					write(request_pipe,info->cmd_msg,MESSAGE_SIZE);
					read(input_pipe, info->cmd_msg, MESSAGE_SIZE);
					sscanf(info->cmd_msg, "%d %d", &val1, &val2);
					if(val1==MSG_REQ_PATTERN_GET_BLENDPARAM) {
						val2--;
						if(val2 > 100) val2 = 0;
						if(val2 < 0) val2 = 100;
						sprintf(info->cmd_msg, "%d %d %d %d",
							MSG_CMD_PATTERN_SET_BLEND_PARAM,
							val2,
							t->cursor_ch,
							t->patpos);
						write(request_pipe,info->cmd_msg, MESSAGE_SIZE);
					}
					break;
				case 4:
					sprintf(info->cmd_msg, "%d %d %d %d", MSG_CMD_PATTERN_INCREASE_CHAIN,
					t->patpos, t->cursor_ch, -1);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					break;
				case 5:
					sprintf(info->cmd_msg, "%d %d %d %d", MSG_CMD_PATTERN_INCREASE_OPERATION,
						t->patpos, t->cursor_ch,-1);
					write(request_pipe, info->cmd_msg, MESSAGE_SIZE);
					break;
			

			}
			tracker_redraw_current_row(t);
			retval = TRUE;
			break;
		*/
		case GDK_Tab:
		case GDK_ISO_Left_Tab:
			tracker_step_cursor_column(t, shift ? -1:1);
			sprintf(info->cmd_msg, "%d %d %d", MSG_CMD_PATTERN_SET_ROW,t->patpos, t->cursor_ch);
			vj_comm_write(info->cmd_msg);
			retval = TRUE;
			break;	
	}		

	return retval;
}

gint keyevent(GtkWidget *widget, GdkEventKey *event, gpointer data) {


	gboolean pressed = (gboolean)data;
	gboolean retval = FALSE;
	gboolean entry_focus = GTK_IS_ENTRY(GTK_WINDOW(MainWindow)->focus_widget);
	vjcomm *info = vj_comm_get_info();

	if (!entry_focus ) {
		gint shift = event->state & GDK_SHIFT_MASK;
		gint ctrl = event->state & GDK_CONTROL_MASK;
		gint alt = event->state & GDK_MOD1_MASK;
		if(pressed) retval = track_edit_handle_key(info,shift,ctrl,alt,event->keyval,pressed);
		//retval = TRUE;
		if(retval) {
			if(pressed) gtk_signal_emit_stop_by_name(GTK_OBJECT(widget), "key_press_event");
			else gtk_signal_emit_stop_by_name(GTK_OBJECT(widget), "key_release_event");
		}
	}
	else {
		if(pressed) {
			switch(event->keyval) {
				case GDK_Tab:
				case GDK_Return:
					gtk_signal_emit_stop_by_name(GTK_OBJECT(widget), "key_press_event");
					gtk_window_set_focus(GTK_WINDOW(MainWindow),NULL);
					break;
			}
		}
	}
	return retval;
}

